#![allow(dead_code)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(unused_attributes)]
pub mod Array_ {
    use super::*;
    use crate::module_2031347a::Native_::arrayCopy;
    use crate::module_2031347a::Native_::arrayCreate;
    use crate::module_2031347a::Native_::arrayEmpty;
    use crate::module_2031347a::Native_::arrayFrom;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::comparer as comparer_1;
    use crate::module_2031347a::Native_::defaultOf;
    use crate::module_2031347a::Native_::getZero;
    use crate::module_2031347a::Native_::hashMapAdd;
    use crate::module_2031347a::Native_::hashMapEmpty;
    use crate::module_2031347a::Native_::hashMapGet;
    use crate::module_2031347a::Native_::hashMapSet;
    use crate::module_2031347a::Native_::hashSetEmpty;
    use crate::module_2031347a::Native_::hashSetFrom;
    use crate::module_2031347a::Native_::tryGetValue;
    use crate::module_2031347a::Native_::HashMap;
    use crate::module_2031347a::Native_::HashSet;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::defaultArg;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_912d02ed::Interfaces_::IEnumerable_1;
    use crate::module_9d52c5fc::Seq_::toArray;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    pub mod SR {
        use super::*;
        use crate::module_2031347a::Native_::thread_local;
        use crate::module_2031347a::Native_::Lrc;
        use crate::module_c5a2a64e::String_::string;
        pub fn indexOutOfBounds() -> Lrc<str> {
            thread_local! {
                        static indexOutOfBounds: Lrc<str> =
            string("The index was outside the range of elements in the array.");
                    };
            indexOutOfBounds.with(|value| value.clone())
        }
        pub fn inputArrayWasEmpty() -> Lrc<str> {
            thread_local! {
                static inputArrayWasEmpty: Lrc<str> = string("The input array was empty");
            };
            inputArrayWasEmpty.with(|value| value.clone())
        }
        pub fn inputArrayWasTooLong() -> Lrc<str> {
            thread_local! {
                        static inputArrayWasTooLong: Lrc<str> =
            string("The input array was too long");
                    };
            inputArrayWasTooLong.with(|value| value.clone())
        }
        pub fn inputArrayWasTooShort() -> Lrc<str> {
            thread_local! {
                        static inputArrayWasTooShort: Lrc<str> =
            string("The input array has not enough elements");
                    };
            inputArrayWasTooShort.with(|value| value.clone())
        }
        pub fn inputMustBeNonNegative() -> Lrc<str> {
            thread_local! {
                        static inputMustBeNonNegative: Lrc<str> =
            string("The input must be non-negative");
                    };
            inputMustBeNonNegative.with(|value| value.clone())
        }
        pub fn inputMustBePositive() -> Lrc<str> {
            thread_local! {
                static inputMustBePositive: Lrc<str> = string("The input must be positive");
            };
            inputMustBePositive.with(|value| value.clone())
        }
        pub fn keyNotFoundAlt() -> Lrc<str> {
            thread_local! {
                        static keyNotFoundAlt: Lrc<str> =
            string("An index satisfying the predicate was not found in the collection.");
                    };
            keyNotFoundAlt.with(|value| value.clone())
        }
        pub fn differentLengths() -> Lrc<str> {
            thread_local! {
                static differentLengths: Lrc<str> = string("Arrays had different lengths");
            };
            differentLengths.with(|value| value.clone())
        }
        pub fn invalidPermutation() -> Lrc<str> {
            thread_local! {
                static invalidPermutation: Lrc<str> = string("Not a valid permutation");
            };
            invalidPermutation.with(|value| value.clone())
        }
    }
    pub fn indexNotFound<_a: Clone + 'static>() -> _a {
        panic!("{}", Array_::SR::keyNotFoundAlt())
    }
    pub fn differentLengths<_a: Clone + 'static>() -> _a {
        panic!("{}", Array_::SR::differentLengths())
    }
    pub fn empty<T: Clone + 'static>() -> Lrc<MutCell<Vec<T>>> {
        arrayCreate(&0i32, &defaultOf::<T>())
    }
    pub fn create<T: Clone + 'static>(count: i32, value: T) -> Lrc<MutCell<Vec<T>>> {
        arrayCreate(&count, &value)
    }
    pub fn zeroCreate<T: Clone + 'static>(count: i32) -> Lrc<MutCell<Vec<T>>> {
        arrayCreate(&count, &defaultOf::<T>())
    }
    pub fn singleton<T: Clone + 'static>(value: T) -> Lrc<MutCell<Vec<T>>> {
        arrayCreate(&1i32, &value)
    }
    pub fn isEmpty<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> bool {
        source.is_empty()
    }
    pub fn length<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> i32 {
        source.len() as i32
    }
    pub fn item<T: Clone + 'static>(index: i32, source: Lrc<MutCell<Vec<T>>>) -> T {
        source[index].clone()
    }
    pub fn get<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>, index: i32) -> T {
        source[index].clone()
    }
    pub fn set<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>, index: i32, value: T) {
        source.get_mut()[index as usize] = value;
    }
    pub fn copy<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Lrc<MutCell<Vec<T>>> {
        arrayCopy(source)
    }
    pub fn tryItem<T: Clone + 'static>(index: i32, source: Lrc<MutCell<Vec<T>>>) -> Option<T> {
        if if index < 0i32 {
            true
        } else {
            index >= source.len() as i32
        } {
            None::<T>
        } else {
            Some(source[index].clone())
        }
    }
    pub fn reverse<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayCopy(source);
        res.clone().get_mut().reverse();
        res.clone()
    }
    pub fn fill<T: Clone + 'static>(
        target: Lrc<MutCell<Vec<T>>>,
        targetIndex: i32,
        count: i32,
        value: T,
    ) {
        if if targetIndex < 0i32 {
            true
        } else {
            targetIndex + count > target.len() as i32
        } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let len: i32 = target.len() as i32;
            for i in targetIndex..=targetIndex + count - 1i32 {
                target.get_mut()[i as usize] = value.clone();
            }
        }
    }
    pub fn getSubArray<T: Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
        startIndex: i32,
        count: i32,
    ) -> Lrc<MutCell<Vec<T>>> {
        if if startIndex < 0i32 {
            true
        } else {
            startIndex + count > source.len() as i32
        } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(source[startIndex + i].clone());
            }
            res.clone()
        }
    }
    pub fn exactlyOne<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> T {
        if source.len() as i32 == 1i32 {
            source[0i32].clone()
        } else {
            if source.is_empty() {
                panic!(
                    "{}",
                    Lrc::from(
                        (Lrc::from(
                            Array_::SR::inputArrayWasEmpty().to_string()
                                + &string("\\nParameter name: ")
                        ) as Lrc<str>)
                            .to_string()
                            + &string("source")
                    ) as Lrc<str>
                )
            } else {
                panic!(
                    "{}",
                    Lrc::from(
                        (Lrc::from(
                            Array_::SR::inputArrayWasTooLong().to_string()
                                + &string("\\nParameter name: ")
                        ) as Lrc<str>)
                            .to_string()
                            + &string("source")
                    ) as Lrc<str>
                )
            }
        }
    }
    pub fn tryExactlyOne<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Option<T> {
        if source.len() as i32 == 1i32 {
            Some(source[0i32].clone())
        } else {
            None::<T>
        }
    }
    pub fn head<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasEmpty().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            )
        } else {
            source[0i32].clone()
        }
    }
    pub fn tryHead<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Option<T> {
        if source.is_empty() {
            None::<T>
        } else {
            Some(source[0i32].clone())
        }
    }
    pub fn last<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasEmpty().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            )
        } else {
            source[source.len() as i32 - 1i32].clone()
        }
    }
    pub fn tryLast<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Option<T> {
        if source.is_empty() {
            None::<T>
        } else {
            Some(source[source.len() as i32 - 1i32].clone())
        }
    }
    pub fn tail<T: Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) -> Lrc<MutCell<Vec<T>>> {
        if source.is_empty() {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasTooShort().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            );
        }
        Array_::getSubArray(source.clone(), 1i32, source.len() as i32 - 1i32)
    }
    pub fn append<T: Clone + 'static>(
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len1 + len2);
        for i in 0i32..=len1 - 1i32 {
            res.get_mut().push(source1[i].clone());
        }
        for i_1 in 0i32..=len2 - 1i32 {
            res.get_mut().push(source2[i_1].clone());
        }
        res.clone()
    }
    pub fn choose<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<impl Fn(T) -> (Option<U>) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        let res: Lrc<MutCell<Vec<U>>> = arrayEmpty::<U>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            let matchValue: Option<U> = chooser(source[i].clone());
            match &matchValue {
                None => (),
                Some(matchValue_0_0) => {
                    let x: U = matchValue_0_0.clone();
                    res.get_mut().push(x.clone())
                }
            }
        }
        res.clone()
    }
    pub fn compareWith<T: Clone + 'static>(
        comparer: Lrc<impl Fn(T, T) -> (i32) + 'static>,
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) -> i32 {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        let len: i32 = if len1 < len2 { len1 } else { len2 };
        let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        let res: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        while if res.get() == 0i32 {
            i.get() < len
        } else {
            false
        } {
            res.set(comparer(source1[i.get()].clone(), source2[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        if !(res.get() == 0i32) {
            res.get()
        } else {
            if len1 > len2 {
                1i32
            } else {
                if len1 < len2 {
                    -1i32
                } else {
                    0i32
                }
            }
        }
    }
    pub fn compareTo<T: PartialOrd + Clone + 'static>(
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) -> i32 {
        let len1: i32 = source1.len() as i32;
        let len2: i32 = source2.len() as i32;
        if len1 > len2 {
            1i32
        } else {
            if len1 < len2 {
                -1i32
            } else {
                let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
                let res: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
                while if res.get() == 0i32 {
                    i.get() < len1
                } else {
                    false
                } {
                    res.set(compare(source1[i.get()].clone(), source2[i.get()].clone()));
                    i.set(i.get() + 1i32)
                }
                res.get()
            }
        }
    }
    pub fn equals<T: Eq + core::hash::Hash + Clone + 'static>(
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) -> bool {
        let len1: i32 = source1.len() as i32;
        if len1 == source2.len() as i32 {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
            let res: Lrc<MutCell<bool>> = Lrc::from(MutCell::from(true));
            while if res.get() { i.get() < len1 } else { false } {
                res.set(source1[i.get()].clone() == source2[i.get()].clone());
                i.set(i.get() + 1i32)
            }
            res.get()
        } else {
            false
        }
    }
    pub fn mapIndexed<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(i32, T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(i, source[i].clone()));
        }
        res.clone()
    }
    pub fn map<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(mapping(source[i].clone()));
        }
        res.clone()
    }
    pub fn mapIndexed2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(i32, T1, T2) -> (U) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(mapping(i, source1[i].clone(), source2[i].clone()));
            }
            res.clone()
        }
    }
    pub fn map2<T1: Clone + 'static, T2: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(T1, T2) -> (U) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(mapping(source1[i].clone(), source2[i].clone()));
            }
            res.clone()
        }
    }
    pub fn map3<
        T1: Clone + 'static,
        T2: Clone + 'static,
        T3: Clone + 'static,
        U: Clone + 'static,
    >(
        mapping: Lrc<impl Fn(T1, T2, T3) -> (U) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
        source3: Lrc<MutCell<Vec<T3>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        if if !(source1.len() as i32 == source2.len() as i32) {
            true
        } else {
            !(source2.len() as i32 == source3.len() as i32)
        } {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut().push(mapping(
                    source1[i].clone(),
                    source2[i].clone(),
                    source3[i].clone(),
                ));
            }
            res.clone()
        }
    }
    pub fn mapFold<State: Clone + 'static, T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(State, T) -> (Lrc<(U, State)>) + 'static>,
        state: State,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<(Lrc<MutCell<Vec<U>>>, State)> {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in 0i32..=len - 1i32 {
            let m: Lrc<(U, State)> = mapping(acc.get().clone(), source[i].clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        Lrc::from((res.clone(), acc.get().clone()))
    }
    pub fn mapFoldBack<T: Clone + 'static, State: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(T, State) -> (Lrc<(U, State)>) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
        state: State,
    ) -> Lrc<(Lrc<MutCell<Vec<U>>>, State)> {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<U>>> = arrayWithCapacity::<U>(len);
        for i in (0i32..=len - 1i32).rev() {
            let m: Lrc<(U, State)> = mapping(source[i].clone(), acc.get().clone());
            res.get_mut().push(m.0.clone());
            acc.set(m.1.clone())
        }
        res.get_mut().reverse();
        Lrc::from((res.clone(), acc.get().clone()))
    }
    pub fn indexed<T: Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(i32, T)>>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<Lrc<(i32, T)>>>> = arrayWithCapacity::<Lrc<(i32, T)>>(len);
        for i in 0i32..=len - 1i32 {
            res.get_mut().push(Lrc::from((i, source[i].clone())));
        }
        res.clone()
    }
    pub fn concat<T: Clone + 'static>(
        sources: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        for idx in 0i32..=sources.len() as i32 - 1i32 {
            let arr: Lrc<MutCell<Vec<T>>> = sources[idx].clone();
            len.set(len.get() + arr.len() as i32)
        }
        {
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len.get());
            for idx_1 in 0i32..=sources.len() as i32 - 1i32 {
                let arr_1: Lrc<MutCell<Vec<T>>> = sources[idx_1].clone();
                for idx_2 in 0i32..=arr_1.len() as i32 - 1i32 {
                    let x: T = arr_1[idx_2].clone();
                    res.get_mut().push(x.clone())
                }
            }
            res.clone()
        }
    }
    pub fn collect<T: Clone + 'static, U: Clone + 'static>(
        mapping: Lrc<impl Fn(T) -> (Lrc<MutCell<Vec<U>>>) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<U>>> {
        Array_::concat(Array_::map(mapping, source))
    }
    pub fn exists<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> bool {
        let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        let res: Lrc<MutCell<bool>> = Lrc::from(MutCell::from(false));
        while if i.get() < source.len() as i32 {
            !res.get()
        } else {
            false
        } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn exists2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<impl Fn(T1, T2) -> (bool) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> bool {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
            let res: Lrc<MutCell<bool>> = Lrc::from(MutCell::from(false));
            while if i.get() < source1.len() as i32 {
                !res.get()
            } else {
                false
            } {
                res.set(predicate(
                    source1[i.get()].clone(),
                    source2[i.get()].clone(),
                ));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn contains<T: Eq + core::hash::Hash + Clone + 'static>(
        value: T,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> bool {
        Array_::exists(
            Lrc::from({
                let value = value.clone();
                move |x: T| x.clone() == value.clone()
            }),
            source,
        )
    }
    pub fn filter<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res.get_mut().push(source[i].clone());
            };
        }
        res.clone()
    }
    pub fn initialize<T: Clone + 'static>(
        count: i32,
        initializer: Lrc<impl Fn(i32) -> (T) + 'static>,
    ) -> Lrc<MutCell<Vec<T>>> {
        if count < 0i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputMustBeNonNegative().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("count")
                ) as Lrc<str>
            );
        }
        {
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(count);
            for i in 0i32..=count - 1i32 {
                res.get_mut().push(initializer(i));
            }
            res.clone()
        }
    }
    pub fn pairwise<T: Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(T, T)>>>> {
        if (source.len() as i32) < 2i32 {
            arrayEmpty::<Lrc<(T, T)>>()
        } else {
            let len: i32 = source.len() as i32 - 1i32;
            let res: Lrc<MutCell<Vec<Lrc<(T, T)>>>> = arrayWithCapacity::<Lrc<(T, T)>>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(Lrc::from((source[i].clone(), source[i + 1i32].clone())));
            }
            res.clone()
        }
    }
    pub fn partition<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<(Lrc<MutCell<Vec<T>>>, Lrc<MutCell<Vec<T>>>)> {
        let res1: Lrc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        let res2: Lrc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        for i in 0i32..=source.len() as i32 - 1i32 {
            if predicate(source[i].clone()) {
                res1.get_mut().push(source[i].clone())
            } else {
                res2.get_mut().push(source[i].clone())
            };
        }
        Lrc::from((res1.clone(), res2.clone()))
    }
    pub fn reduce<T: Clone + 'static>(
        reduction: Lrc<impl Fn(T, T) -> (T) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        if source.is_empty() {
            panic!("{}", Array_::SR::inputArrayWasEmpty());
        }
        {
            let folder = Lrc::from({
                let reduction = reduction.clone();
                move |i: i32, acc: T, x: T| {
                    if i == 0i32 {
                        x.clone()
                    } else {
                        reduction(acc.clone(), x.clone())
                    }
                }
            });
            let acc_1: Lrc<MutCell<T>> = Lrc::from(MutCell::from(source[0i32].clone()));
            for i_1 in 0i32..=source.len() as i32 - 1i32 {
                acc_1.set(folder(i_1, acc_1.get().clone(), source[i_1].clone()));
            }
            acc_1.get().clone()
        }
    }
    pub fn reduceBack<T: Clone + 'static>(
        reduction: Lrc<impl Fn(T, T) -> (T) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        if source.is_empty() {
            panic!("{}", Array_::SR::inputArrayWasEmpty());
        }
        {
            let folder = Lrc::from({
                let reduction = reduction.clone();
                move |i: i32, x: T, acc: T| {
                    if i == 0i32 {
                        x.clone()
                    } else {
                        reduction(acc.clone(), x.clone())
                    }
                }
            });
            let len: i32 = source.len() as i32;
            let acc_1: Lrc<MutCell<T>> = Lrc::from(MutCell::from(source[len - 1i32].clone()));
            for i_1 in 1i32..=len {
                acc_1.set(folder(
                    i_1 - 1i32,
                    source[len - i_1].clone(),
                    acc_1.get().clone(),
                ));
            }
            acc_1.get().clone()
        }
    }
    pub fn replicate<T: Clone + 'static>(count: i32, initial: T) -> Lrc<MutCell<Vec<T>>> {
        Array_::initialize(
            count,
            Lrc::from({
                let initial = initial.clone();
                move |_arg: i32| initial.clone()
            }),
        )
    }
    pub fn scan<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<impl Fn(State, T) -> (State) + 'static>,
        state: State,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<State>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<State>>> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[0i32 as usize] = state.clone();
        for i in 0i32..=len - 1i32 {
            res.get_mut()[(i + 1i32) as usize] = folder(res[i].clone(), source[i].clone());
        }
        res.clone()
    }
    pub fn scanBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<impl Fn(T, State) -> (State) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
        state: State,
    ) -> Lrc<MutCell<Vec<State>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<State>>> = arrayCreate(&(len + 1i32), &state);
        res.get_mut()[len as usize] = state.clone();
        for i in (0i32..=len - 1i32).rev() {
            res.get_mut()[i as usize] = folder(source[i].clone(), res[i + 1i32].clone());
        }
        res.clone()
    }
    pub fn skip<T: Clone + 'static>(
        count: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        if count > source.len() as i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasTooShort().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            );
        }
        {
            let count_1: i32 = if count < 0i32 { 0i32 } else { count };
            Array_::getSubArray(source.clone(), count_1, source.len() as i32 - count_1)
        }
    }
    pub fn skipWhile<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let count: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        while if count.get() < source.len() as i32 {
            predicate(source[count.get()].clone())
        } else {
            false
        } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(
            source.clone(),
            count.get(),
            source.len() as i32 - count.get(),
        )
    }
    pub fn take<T: Clone + 'static>(
        count: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        if count < 0i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputMustBeNonNegative().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("count")
                ) as Lrc<str>
            );
        }
        if count > source.len() as i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasTooShort().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            );
        }
        Array_::getSubArray(source.clone(), 0i32, count)
    }
    pub fn takeWhile<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let count: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        while if count.get() < source.len() as i32 {
            predicate(source[count.get()].clone())
        } else {
            false
        } {
            count.set(count.get() + 1i32);
        }
        Array_::getSubArray(source.clone(), 0i32, count.get())
    }
    pub fn truncate<T: Clone + 'static>(
        count: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        Array_::getSubArray(
            source.clone(),
            0i32,
            if count < 0i32 {
                0i32
            } else {
                if count > source.len() as i32 {
                    source.len() as i32
                } else {
                    count
                }
            },
        )
    }
    pub fn copyTo<T: Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
        sourceIndex: i32,
        target: Lrc<MutCell<Vec<T>>>,
        targetIndex: i32,
        count: i32,
    ) {
        let diff: i32 = targetIndex - sourceIndex;
        for i in sourceIndex..=sourceIndex + count - 1i32 {
            target.get_mut()[(i + diff) as usize] = source[i].clone();
        }
    }
    pub fn tryFind<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Option<T> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<impl Fn(T) -> (bool) + 'static>,
            source_1: Lrc<MutCell<Vec<T>>>,
        ) -> Option<T> {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
            let predicate_1 = Lrc::from(MutCell::from(predicate_1.clone()));
            let source_1: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                Lrc::from(MutCell::from(source_1.clone()));
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<T>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(source_1[i.get()].clone())
                    } else {
                        let i_temp: i32 = i.get() + 1i32;
                        let predicate_1_temp = predicate_1.get().clone();
                        let source_1_temp: Lrc<MutCell<Vec<T>>> = source_1.get().clone();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn find<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        let matchValue: Option<T> = Array_::tryFind(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndex<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Option<i32> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<impl Fn(T) -> (bool) + 'static>,
            source_1: Lrc<MutCell<Vec<T>>>,
        ) -> Option<i32> {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
            let predicate_1 = Lrc::from(MutCell::from(predicate_1.clone()));
            let source_1: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                Lrc::from(MutCell::from(source_1.clone()));
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<i32>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(i.get())
                    } else {
                        let i_temp: i32 = i.get() + 1i32;
                        let predicate_1_temp = predicate_1.get().clone();
                        let source_1_temp: Lrc<MutCell<Vec<T>>> = source_1.get().clone();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(0i32, predicate, source)
    }
    pub fn findIndex<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndex(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn indexOf<T: Eq + core::hash::Hash + Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
        item: T,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndex(
            Lrc::from({
                let item = item.clone();
                move |x: T| x.clone() == item.clone()
            }),
            source,
        );
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindBack<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Option<T> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<impl Fn(T) -> (bool) + 'static>,
            source_1: Lrc<MutCell<Vec<T>>>,
        ) -> Option<T> {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
            let predicate_1 = Lrc::from(MutCell::from(predicate_1.clone()));
            let source_1: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                Lrc::from(MutCell::from(source_1.clone()));
            '_inner_loop: loop {
                break '_inner_loop (if i.get() < 0i32 {
                    None::<T>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(source_1[i.get()].clone())
                    } else {
                        let i_temp: i32 = i.get() - 1i32;
                        let predicate_1_temp = predicate_1.get().clone();
                        let source_1_temp: Lrc<MutCell<Vec<T>>> = source_1.get().clone();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source.clone())
    }
    pub fn findBack<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        let matchValue: Option<T> = Array_::tryFindBack(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryFindIndexBack<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Option<i32> {
        fn inner_loop<T: Clone + 'static>(
            i: i32,
            predicate_1: Lrc<impl Fn(T) -> (bool) + 'static>,
            source_1: Lrc<MutCell<Vec<T>>>,
        ) -> Option<i32> {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
            let predicate_1 = Lrc::from(MutCell::from(predicate_1.clone()));
            let source_1: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                Lrc::from(MutCell::from(source_1.clone()));
            '_inner_loop: loop {
                break '_inner_loop (if i.get() < 0i32 {
                    None::<i32>
                } else {
                    if predicate_1(source_1[i.get()].clone()) {
                        Some(i.get())
                    } else {
                        let i_temp: i32 = i.get() - 1i32;
                        let predicate_1_temp = predicate_1.get().clone();
                        let source_1_temp: Lrc<MutCell<Vec<T>>> = source_1.get().clone();
                        i.set(i_temp);
                        predicate_1.set(predicate_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    }
                });
            }
        }
        inner_loop(source.len() as i32 - 1i32, predicate, source.clone())
    }
    pub fn findIndexBack<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn findLastIndex<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> i32 {
        let matchValue: Option<i32> = Array_::tryFindIndexBack(predicate, source);
        match &matchValue {
            None => -1i32,
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn tryPick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<impl Fn(T) -> (Option<U>) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Option<U> {
        fn inner_loop<T: Clone + 'static, U: Clone + 'static>(
            i: i32,
            chooser_1: Lrc<impl Fn(T) -> (Option<U>) + 'static>,
            source_1: Lrc<MutCell<Vec<T>>>,
        ) -> Option<U> {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
            let chooser_1 = Lrc::from(MutCell::from(chooser_1.clone()));
            let source_1: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                Lrc::from(MutCell::from(source_1.clone()));
            '_inner_loop: loop {
                break '_inner_loop (if i.get() >= source_1.get().len() as i32 {
                    None::<U>
                } else {
                    let matchValue: Option<U> = chooser_1(source_1[i.get()].clone());
                    if matchValue.is_none() {
                        let i_temp: i32 = i.get() + 1i32;
                        let chooser_1_temp = chooser_1.get().clone();
                        let source_1_temp: Lrc<MutCell<Vec<T>>> = source_1.get().clone();
                        i.set(i_temp);
                        chooser_1.set(chooser_1_temp);
                        source_1.set(source_1_temp);
                        continue '_inner_loop;
                    } else {
                        matchValue.clone()
                    }
                });
            }
        }
        inner_loop(0i32, chooser, source)
    }
    pub fn pick<T: Clone + 'static, U: Clone + 'static>(
        chooser: Lrc<impl Fn(T) -> (Option<U>) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> U {
        let matchValue: Option<U> = Array_::tryPick(chooser, source);
        match &matchValue {
            None => panic!("{}", Array_::SR::keyNotFoundAlt()),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn fold<State: Clone + 'static, T: Clone + 'static>(
        folder: Lrc<impl Fn(State, T) -> (State) + 'static>,
        state: State,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> State {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(folder(acc.get().clone(), source[i].clone()));
        }
        acc.get().clone()
    }
    pub fn foldBack<T: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<impl Fn(T, State) -> (State) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
        state: State,
    ) -> State {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        let len: i32 = source.len() as i32;
        for i in 1i32..=len {
            acc.set(folder(source[len - i].clone(), acc.get().clone()));
        }
        acc.get().clone()
    }
    pub fn fold2<State: Clone + 'static, T1: Clone + 'static, T2: Clone + 'static>(
        folder: Lrc<impl Fn(State, T1, T2) -> (State) + 'static>,
        state: State,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> State {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            acc.set(folder(
                acc.get().clone(),
                source1[i].clone(),
                source2[i].clone(),
            ));
        }
        acc.get().clone()
    }
    pub fn foldBack2<T1: Clone + 'static, T2: Clone + 'static, State: Clone + 'static>(
        folder: Lrc<impl Fn(T1, T2, State) -> (State) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
        state: State,
    ) -> State {
        let acc: Lrc<MutCell<State>> = Lrc::from(MutCell::from(state));
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let len: i32 = source1.len() as i32;
            for i in 1i32..=len {
                acc.set(folder(
                    source1[len - i].clone(),
                    source2[len - i].clone(),
                    acc.get().clone(),
                ));
            }
            acc.get().clone()
        }
    }
    pub fn forAll<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> bool {
        let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
        let res: Lrc<MutCell<bool>> = Lrc::from(MutCell::from(true));
        while if i.get() < source.len() as i32 {
            res.get()
        } else {
            false
        } {
            res.set(predicate(source[i.get()].clone()));
            i.set(i.get() + 1i32)
        }
        res.get()
    }
    pub fn forAll2<T1: Clone + 'static, T2: Clone + 'static>(
        predicate: Lrc<impl Fn(T1, T2) -> (bool) + 'static>,
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> bool {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
            let res: Lrc<MutCell<bool>> = Lrc::from(MutCell::from(true));
            while if i.get() < source1.len() as i32 {
                res.get()
            } else {
                false
            } {
                res.set(predicate(
                    source1[i.get()].clone(),
                    source2[i.get()].clone(),
                ));
                i.set(i.get() + 1i32)
            }
            res.get()
        }
    }
    pub fn iterate<T: Clone + 'static>(
        action: Lrc<impl Fn(T) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(source[i].clone());
        }
    }
    pub fn iterateIndexed<T: Clone + 'static>(
        action: Lrc<impl Fn(i32, T) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) {
        for i in 0i32..=source.len() as i32 - 1i32 {
            action(i, source[i].clone());
        }
    }
    pub fn iterate2<T: Clone + 'static>(
        action: Lrc<impl Fn(T, T) + 'static>,
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(source1[i].clone(), source2[i].clone());
        }
    }
    pub fn iterateIndexed2<T: Clone + 'static>(
        action: Lrc<impl Fn(i32, T, T) + 'static>,
        source1: Lrc<MutCell<Vec<T>>>,
        source2: Lrc<MutCell<Vec<T>>>,
    ) {
        if !(source1.len() as i32 == source2.len() as i32) {
            panic!("{}", Array_::SR::differentLengths());
        }
        for i in 0i32..=source1.len() as i32 - 1i32 {
            action(i, source1[i].clone(), source2[i].clone());
        }
    }
    pub fn permute<T: Clone + 'static>(
        indexMap: Lrc<impl Fn(i32) -> (i32) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len: i32 = source.len() as i32;
        let res: Lrc<MutCell<Vec<T>>> = arrayCopy(source.clone());
        let checkFlags: Lrc<MutCell<Vec<i32>>> = arrayCreate(&len, &0i32);
        Array_::iterateIndexed(
            Lrc::from({
                let checkFlags = checkFlags.clone();
                let indexMap = indexMap.clone();
                let len = len.clone();
                let res = res.clone();
                move |i: i32, x: T| {
                    let j: i32 = indexMap(i);
                    if if j < 0i32 { true } else { j >= len } {
                        panic!("{}", Array_::SR::invalidPermutation());
                    }
                    res.get_mut()[j as usize] = x.clone();
                    checkFlags.get_mut()[j as usize] = 1i32
                }
            }),
            source.clone(),
        );
        if !Array_::forAll(Lrc::from(move |y: i32| 1i32 == y), checkFlags.clone()) {
            panic!("{}", Array_::SR::invalidPermutation());
        }
        res.clone()
    }
    pub fn getSlice<T: Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
        lower: Option<i32>,
        upper: Option<i32>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let patternInput: Lrc<(i32, i32)> = {
            let bound: i32 = 0i32;
            let lower_1: Option<i32> = lower;
            let upper_1: Option<i32> = upper;
            let length: i32 = source.len() as i32;
            Lrc::from((
                if lower_1.is_some() {
                    if getValue(lower_1.clone()) >= bound {
                        let n_1: i32 = getValue(lower_1.clone());
                        n_1
                    } else {
                        bound
                    }
                } else {
                    bound
                },
                if upper_1.is_some() {
                    if getValue(upper_1.clone()) < bound + length {
                        let m_1: i32 = getValue(upper_1.clone());
                        m_1
                    } else {
                        bound + length - 1i32
                    }
                } else {
                    bound + length - 1i32
                },
            ))
        };
        let start: i32 = patternInput.0.clone();
        Array_::getSubArray(source.clone(), start, patternInput.1.clone() - start + 1i32)
    }
    pub fn setSlice<T: Clone + 'static>(
        target: Lrc<MutCell<Vec<T>>>,
        lower: Option<i32>,
        upper: Option<i32>,
        source: Lrc<MutCell<Vec<T>>>,
    ) {
        let start: i32 = defaultArg(lower, 0i32);
        let count: i32 = defaultArg(upper, target.len() as i32 - 1i32) - start + 1i32;
        for i in 0i32..=count - 1i32 {
            target.get_mut()[(start + i) as usize] = source[i].clone();
        }
    }
    pub fn sortInPlaceWith<T: Clone + 'static>(
        comparer: Lrc<impl Fn(T, T) -> (i32) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) {
        source.get_mut().sort_by(comparer_1(Lrc::from({
            let comparer = comparer.clone();
            move |delegateArg: T, delegateArg_1: T| {
                comparer(delegateArg.clone(), delegateArg_1.clone())
            }
        })));
    }
    pub fn sortInPlace<T: PartialOrd + Clone + 'static>(source: Lrc<MutCell<Vec<T>>>) {
        Array_::sortInPlaceWith(
            Lrc::from(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            source,
        );
    }
    pub fn sortInPlaceBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) {
        Array_::sortInPlaceWith(
            Lrc::from({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone()))
            }),
            source,
        );
    }
    pub fn sort<T: PartialOrd + Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlace(res.clone());
        res.clone()
    }
    pub fn sortBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlaceBy(projection, res.clone());
        res.clone()
    }
    pub fn sortWith<T: Clone + 'static>(
        comparer: Lrc<impl Fn(T, T) -> (i32) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayCopy(source);
        Array_::sortInPlaceWith(comparer, res.clone());
        res.clone()
    }
    pub fn sortDescending<T: PartialOrd + Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        Array_::sortWith(
            Lrc::from(move |x: T, y: T| compare(x.clone(), y.clone()) * -1i32),
            source,
        )
    }
    pub fn sortByDescending<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        Array_::sortWith(
            Lrc::from({
                let projection = projection.clone();
                move |x: T, y: T| compare(projection(x.clone()), projection(y.clone())) * -1i32
            }),
            source,
        )
    }
    pub fn allPairs<T1: Clone + 'static, T2: Clone + 'static>(
        xs: Lrc<MutCell<Vec<T1>>>,
        ys: Lrc<MutCell<Vec<T2>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(T1, T2)>>>> {
        let len1: i32 = xs.len() as i32;
        let len2: i32 = ys.len() as i32;
        let res: Lrc<MutCell<Vec<Lrc<(T1, T2)>>>> = arrayWithCapacity::<Lrc<(T1, T2)>>(len1 * len2);
        for i in 0i32..=len1 - 1i32 {
            for j in 0i32..=len2 - 1i32 {
                res.get_mut()
                    .push(Lrc::from((xs[i].clone(), ys[j].clone())));
            }
        }
        res.clone()
    }
    pub fn unfold<State: Clone + 'static, T: Clone + 'static>(
        generator: Lrc<impl Fn(State) -> (Option<Lrc<(T, State)>>) + 'static>,
        state: State,
    ) -> Lrc<MutCell<Vec<T>>> {
        fn inner_loop<_a: Clone + 'static, T: Clone + 'static>(
            generator_1: Lrc<impl Fn(_a) -> (Option<Lrc<(T, _a)>>) + 'static>,
            state_1: _a,
            res: Lrc<MutCell<Vec<T>>>,
        ) {
            let generator_1 = Lrc::from(MutCell::from(generator_1.clone()));
            let state_1: Lrc<MutCell<_a>> = Lrc::from(MutCell::from(state_1));
            let res: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> = Lrc::from(MutCell::from(res.clone()));
            '_inner_loop: loop {
                break '_inner_loop ({
                    let matchValue: Option<Lrc<(T, _a)>> = generator_1(state_1.get().clone());
                    match &matchValue {
                        Some(matchValue_0_0) => {
                            let x: T = matchValue_0_0.0.clone();
                            let s: _a = matchValue_0_0.1.clone();
                            res.get().get_mut().push(x);
                            {
                                let generator_1_temp = generator_1.get().clone();
                                let state_1_temp: _a = s;
                                let res_temp: Lrc<MutCell<Vec<T>>> = res.get().clone();
                                generator_1.set(generator_1_temp);
                                state_1.set(state_1_temp);
                                res.set(res_temp);
                                continue '_inner_loop;
                            }
                        }
                        _ => (),
                    }
                });
            }
        }
        let res_1: Lrc<MutCell<Vec<T>>> = arrayEmpty::<T>();
        inner_loop(generator, state, res_1.clone());
        res_1.clone()
    }
    pub fn unzip<T1: Clone + 'static, T2: Clone + 'static>(
        source: Lrc<MutCell<Vec<Lrc<(T1, T2)>>>>,
    ) -> Lrc<(Lrc<MutCell<Vec<T1>>>, Lrc<MutCell<Vec<T2>>>)> {
        let len: i32 = source.len() as i32;
        let res1: Lrc<MutCell<Vec<T1>>> = arrayWithCapacity::<T1>(len);
        let res2: Lrc<MutCell<Vec<T2>>> = arrayWithCapacity::<T2>(len);
        Array_::iterateIndexed(
            Lrc::from({
                let res1 = res1.clone();
                let res2 = res2.clone();
                move |i: i32, tupledArg: Lrc<(T1, T2)>| {
                    res1.get_mut().push(tupledArg.0.clone());
                    res2.get_mut().push(tupledArg.1.clone())
                }
            }),
            source.clone(),
        );
        Lrc::from((res1.clone(), res2.clone()))
    }
    pub fn unzip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone + 'static>(
        source: Lrc<MutCell<Vec<Lrc<(T1, T2, T3)>>>>,
    ) -> Lrc<(
        Lrc<MutCell<Vec<T1>>>,
        Lrc<MutCell<Vec<T2>>>,
        Lrc<MutCell<Vec<T3>>>,
    )> {
        let len: i32 = source.len() as i32;
        let res1: Lrc<MutCell<Vec<T1>>> = arrayWithCapacity::<T1>(len);
        let res2: Lrc<MutCell<Vec<T2>>> = arrayWithCapacity::<T2>(len);
        let res3: Lrc<MutCell<Vec<T3>>> = arrayWithCapacity::<T3>(len);
        Array_::iterateIndexed(
            Lrc::from({
                let res1 = res1.clone();
                let res2 = res2.clone();
                let res3 = res3.clone();
                move |i: i32, tupledArg: Lrc<(T1, T2, T3)>| {
                    res1.get_mut().push(tupledArg.0.clone());
                    res2.get_mut().push(tupledArg.1.clone());
                    res3.get_mut().push(tupledArg.2.clone())
                }
            }),
            source.clone(),
        );
        Lrc::from((res1.clone(), res2.clone(), res3.clone()))
    }
    pub fn zip<T1: Clone + 'static, T2: Clone + 'static>(
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(T1, T2)>>>> {
        Array_::map2(
            Lrc::from(move |x: T1, y: T2| Lrc::from((x.clone(), y.clone()))),
            source1,
            source2,
        )
    }
    pub fn zip3<T1: Clone + 'static, T2: Clone + 'static, T3: Clone + 'static>(
        source1: Lrc<MutCell<Vec<T1>>>,
        source2: Lrc<MutCell<Vec<T2>>>,
        source3: Lrc<MutCell<Vec<T3>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(T1, T2, T3)>>>> {
        Array_::map3(
            Lrc::from(move |x: T1, y: T2, z: T3| Lrc::from((x.clone(), y.clone(), z.clone()))),
            source1,
            source2,
            source3,
        )
    }
    pub fn chunkBySize<T: Clone + 'static>(
        chunkSize: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> {
        if chunkSize <= 0i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputMustBePositive().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("size")
                ) as Lrc<str>
            );
        }
        {
            let len: i32 = source.len() as i32;
            let chunkCount: i32 = (len - 1i32) / chunkSize + 1i32;
            let res: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Lrc<MutCell<Vec<T>>>>(chunkCount);
            for i in 0i32..=chunkCount - 1i32 {
                let start: i32 = i * chunkSize;
                let slice: Lrc<MutCell<Vec<T>>> =
                    Array_::getSubArray(source.clone(), start, chunkSize.min(len - start));
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn splitAt<T: Clone + 'static>(
        index: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<(Lrc<MutCell<Vec<T>>>, Lrc<MutCell<Vec<T>>>)> {
        if if index < 0i32 {
            true
        } else {
            index > source.len() as i32
        } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        Lrc::from((
            Array_::getSubArray(source.clone(), 0i32, index),
            Array_::getSubArray(source.clone(), index, source.len() as i32 - index),
        ))
    }
    pub fn sum<T: core::ops::Add<Output = T> + Default + Clone + 'static>(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        let acc: Lrc<MutCell<T>> = Lrc::from(MutCell::from(getZero::<T>()));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + source[i].clone());
        }
        acc.get().clone()
    }
    pub fn sumBy<T: Clone + 'static, U: core::ops::Add<Output = U> + Default + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> U {
        let acc: Lrc<MutCell<U>> = Lrc::from(MutCell::from(getZero::<U>()));
        for i in 0i32..=source.len() as i32 - 1i32 {
            acc.set(acc.get().clone() + projection(source[i].clone()));
        }
        acc.get().clone()
    }
    pub fn maxBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        Array_::reduce(
            Lrc::from({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) > projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn max<T: PartialOrd + Clone + 'static>(xs: Lrc<MutCell<Vec<T>>>) -> T {
        Array_::reduce(
            Lrc::from(move |x: T, y: T| {
                if x.clone() > y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn minBy<T: Clone + 'static, U: PartialOrd + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        Array_::reduce(
            Lrc::from({
                let projection = projection.clone();
                move |x: T, y: T| {
                    if projection(x.clone()) < projection(y.clone()) {
                        x.clone()
                    } else {
                        y.clone()
                    }
                }
            }),
            xs,
        )
    }
    pub fn min<T: PartialOrd + Clone + 'static>(xs: Lrc<MutCell<Vec<T>>>) -> T {
        Array_::reduce(
            Lrc::from(move |x: T, y: T| {
                if x.clone() < y.clone() {
                    x.clone()
                } else {
                    y.clone()
                }
            }),
            xs,
        )
    }
    pub fn average<
        T: core::ops::Add<Output = T>
            + core::ops::Div<Output = T>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        source: Lrc<MutCell<Vec<T>>>,
    ) -> T {
        if source.is_empty() {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasEmpty().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            );
        }
        {
            let total: Lrc<MutCell<T>> = Lrc::from(MutCell::from(getZero::<T>()));
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() + source[i].clone());
            }
            total.get().clone() / T::from(source.len() as i32)
        }
    }
    pub fn averageBy<
        T: Clone + 'static,
        U: core::ops::Add<Output = U>
            + core::ops::Div<Output = U>
            + From<i32>
            + Default
            + Clone
            + 'static,
    >(
        projection: Lrc<impl Fn(T) -> (U) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> U {
        if source.is_empty() {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputArrayWasEmpty().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("source")
                ) as Lrc<str>
            );
        }
        {
            let total: Lrc<MutCell<U>> = Lrc::from(MutCell::from(getZero::<U>()));
            for i in 0i32..=source.len() as i32 - 1i32 {
                total.set(total.get().clone() + projection(source[i].clone()));
            }
            total.get().clone() / U::from(source.len() as i32)
        }
    }
    pub fn ofOption<T: Clone + 'static>(opt: Option<T>) -> Lrc<MutCell<Vec<T>>> {
        match &opt {
            None => arrayCreate(&0i32, &defaultOf::<T>()),
            Some(opt_0_0) => arrayCreate(&1i32, &opt_0_0),
        }
    }
    pub fn r#where<T: Clone + 'static>(
        predicate: Lrc<impl Fn(T) -> (bool) + 'static>,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        Array_::filter(predicate, source)
    }
    pub fn windowed<T: Clone + 'static>(
        windowSize: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> {
        if windowSize <= 0i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputMustBePositive().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("size")
                ) as Lrc<str>
            );
        }
        {
            let len: i32 = 0i32.max(source.len() as i32 - windowSize + 1i32);
            let res: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Lrc<MutCell<Vec<T>>>>(len);
            for i in 0i32..=len - 1i32 {
                let slice: Lrc<MutCell<Vec<T>>> =
                    Array_::getSubArray(source.clone(), i, windowSize);
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn splitInto<T: Clone + 'static>(
        chunks: i32,
        source: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> {
        if chunks <= 0i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::inputMustBePositive().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("chunks")
                ) as Lrc<str>
            );
        }
        if source.is_empty() {
            arrayEmpty::<Lrc<MutCell<Vec<T>>>>()
        } else {
            let res: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> =
                arrayWithCapacity::<Lrc<MutCell<Vec<T>>>>(chunks);
            let chunks_1: i32 = chunks.min(source.len() as i32);
            let minChunkSize: i32 = source.len() as i32 / chunks_1;
            let chunksWithExtraItem: i32 = source.len() as i32 % chunks_1;
            for i in 0i32..=chunks_1 - 1i32 {
                let chunkSize: i32 = if i < chunksWithExtraItem {
                    minChunkSize + 1i32
                } else {
                    minChunkSize
                };
                let slice: Lrc<MutCell<Vec<T>>> = Array_::getSubArray(
                    source.clone(),
                    i * minChunkSize + chunksWithExtraItem.min(i),
                    chunkSize,
                );
                res.get_mut().push(slice.clone())
            }
            res.clone()
        }
    }
    pub fn transpose<T: Clone + 'static>(
        arrays: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>>,
    ) -> Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> {
        if arrays.is_empty() {
            arrayEmpty::<Lrc<MutCell<Vec<T>>>>()
        } else {
            let len: i32 = arrays.len() as i32;
            let firstArray: Lrc<MutCell<Vec<T>>> = arrays[0i32].clone();
            let innerLen: i32 = firstArray.len() as i32;
            if !Array_::forAll(
                Lrc::from({
                    let innerLen = innerLen.clone();
                    move |a_2: Lrc<MutCell<Vec<T>>>| a_2.len() as i32 == innerLen
                }),
                arrays.clone(),
            ) {
                panic!("{}", Array_::SR::differentLengths());
            }
            {
                let res: Lrc<MutCell<Vec<Lrc<MutCell<Vec<T>>>>>> =
                    arrayWithCapacity::<Lrc<MutCell<Vec<T>>>>(innerLen);
                for i in 0i32..=innerLen - 1i32 {
                    let res2: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len);
                    for j in 0i32..=len - 1i32 {
                        res2.get_mut().push(arrays[j].clone()[i].clone());
                    }
                    res.get_mut().push(res2.clone())
                }
                res.clone()
            }
        }
    }
    pub fn distinct<T: Eq + core::hash::Hash + Clone + 'static>(
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let hashSet: Lrc<MutCell<HashSet<T>>> = hashSetEmpty::<T>();
        Array_::filter(
            Lrc::from({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn distinctBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (Key) + 'static>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let hashSet: Lrc<MutCell<HashSet<Key>>> = hashSetEmpty::<Key>();
        Array_::filter(
            Lrc::from({
                let hashSet = hashSet.clone();
                let projection = projection.clone();
                move |x: T| hashSet.get_mut().insert(projection(x.clone()))
            }),
            xs,
        )
    }
    pub fn except<T: Eq + core::hash::Hash + Clone + 'static>(
        itemsToExclude: Lrc<dyn IEnumerable_1<T>>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let hashSet: Lrc<MutCell<HashSet<T>>> = hashSetFrom(toArray(itemsToExclude));
        Array_::filter(
            Lrc::from({
                let hashSet = hashSet.clone();
                move |x: T| hashSet.get_mut().insert(x.clone())
            }),
            xs,
        )
    }
    pub fn countBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (Key) + 'static>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(Key, i32)>>>> {
        let dict: Lrc<MutCell<HashMap<Key, i32>>> = hashMapEmpty::<Key, i32>();
        let keys: Lrc<MutCell<Vec<Key>>> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let key: Key = projection(xs[idx].clone());
            let matchValue: Lrc<(bool, i32)> = {
                let outArg: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(0i32));
                Lrc::from((
                    tryGetValue(dict.clone(), key.clone(), &outArg),
                    outArg.get(),
                ))
            };
            if matchValue.0.clone() {
                hashMapSet(dict.clone(), key.clone(), matchValue.1.clone() + 1i32)
            } else {
                hashMapSet(dict.clone(), key.clone(), 1i32);
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(
            Lrc::from({
                let dict = dict.clone();
                move |key_1: Key| {
                    Lrc::from((key_1.clone(), hashMapGet(dict.clone(), key_1.clone())))
                }
            }),
            keys.clone(),
        )
    }
    pub fn groupBy<T: Clone + 'static, Key: Eq + core::hash::Hash + Clone + 'static>(
        projection: Lrc<impl Fn(T) -> (Key) + 'static>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(Key, Lrc<MutCell<Vec<T>>>)>>>> {
        let dict: Lrc<MutCell<HashMap<Key, Lrc<MutCell<Vec<T>>>>>> =
            hashMapEmpty::<Key, Lrc<MutCell<Vec<T>>>>();
        let keys: Lrc<MutCell<Vec<Key>>> = arrayEmpty::<Key>();
        for idx in 0i32..=xs.len() as i32 - 1i32 {
            let x: T = xs[idx].clone();
            let key: Key = projection(x.clone());
            let matchValue: Lrc<(bool, Lrc<MutCell<Vec<T>>>)> = {
                let outArg: Lrc<MutCell<Lrc<MutCell<Vec<T>>>>> =
                    Lrc::from(MutCell::from(arrayEmpty::<T>()));
                Lrc::from((
                    tryGetValue(dict.clone(), key.clone(), &outArg),
                    outArg.get().clone(),
                ))
            };
            if matchValue.0.clone() {
                matchValue.1.clone().get_mut().push(x.clone())
            } else {
                hashMapAdd(dict.clone(), key.clone(), arrayFrom(&[x]));
                keys.get_mut().push(key.clone())
            }
        }
        Array_::map(
            Lrc::from({
                let dict = dict.clone();
                move |key_1: Key| {
                    Lrc::from((key_1.clone(), hashMapGet(dict.clone(), key_1.clone())))
                }
            }),
            keys.clone(),
        )
    }
    pub fn insertAt<T: Clone + 'static>(
        index: i32,
        y: T,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len + 1i32);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            res.get_mut().push(y);
            for i_1 in index..=len - 1i32 {
                res.get_mut().push(xs[i_1].clone());
            }
            res.clone()
        }
    }
    pub fn insertManyAt<T: Clone + 'static>(
        index: i32,
        ys: Lrc<dyn IEnumerable_1<T>>,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index > len } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let ys_1: Lrc<MutCell<Vec<T>>> = toArray(ys);
            let len2: i32 = ys_1.len() as i32;
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len + len2);
            for i in 0i32..=index - 1i32 {
                res.get_mut().push(xs[i].clone());
            }
            for i_1 in 0i32..=len2 - 1i32 {
                res.get_mut().push(ys_1[i_1].clone());
            }
            for i_2 in index..=len - 1i32 {
                res.get_mut().push(xs[i_2].clone());
            }
            res.clone()
        }
    }
    pub fn removeAt<T: Clone + 'static>(
        index: i32,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        if if index < 0i32 {
            true
        } else {
            index >= xs.len() as i32
        } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(-1i32));
            Array_::filter(
                Lrc::from({
                    let i = i.clone();
                    let index = index.clone();
                    move |_arg: T| {
                        i.set(i.get() + 1i32);
                        !(i.get() == index)
                    }
                }),
                xs.clone(),
            )
        }
    }
    pub fn removeManyAt<T: Clone + 'static>(
        index: i32,
        count: i32,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let i: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(-1i32));
        let status: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(-1i32));
        let res: Lrc<MutCell<Vec<T>>> = Array_::filter(
            Lrc::from({
                let count = count.clone();
                let i = i.clone();
                let index = index.clone();
                let status = status.clone();
                move |_arg: T| {
                    i.set(i.get() + 1i32);
                    if i.get() == index {
                        status.set(0i32);
                        false
                    } else {
                        if i.get() > index {
                            if i.get() < index + count {
                                false
                            } else {
                                status.set(1i32);
                                true
                            }
                        } else {
                            true
                        }
                    }
                }
            }),
            xs,
        );
        let status_1: i32 = if if status.get() == 0i32 {
            i.get() + 1i32 == index + count
        } else {
            false
        } {
            1i32
        } else {
            status.get()
        };
        if status_1 < 1i32 {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &(if status_1 < 0i32 {
                            string("index")
                        } else {
                            string("count")
                        })
                ) as Lrc<str>
            );
        }
        res
    }
    pub fn updateAt<T: Clone + 'static>(
        index: i32,
        y: T,
        xs: Lrc<MutCell<Vec<T>>>,
    ) -> Lrc<MutCell<Vec<T>>> {
        let len: i32 = xs.len() as i32;
        if if index < 0i32 { true } else { index >= len } {
            panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Array_::SR::indexOutOfBounds().to_string() + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("index")
                ) as Lrc<str>
            );
        }
        {
            let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(len);
            for i in 0i32..=len - 1i32 {
                res.get_mut()
                    .push(if i == index { y.clone() } else { xs[i].clone() });
            }
            res.clone()
        }
    }
}
