#![allow(dead_code)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(unused_attributes)]
pub mod Map_ {
    use super::*;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::defaultOf;
    use crate::module_2031347a::Native_::List_1;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_264daaf9::List_::cons;
    use crate::module_264daaf9::List_::empty as empty_1;
    use crate::module_264daaf9::List_::fold as fold_2;
    use crate::module_264daaf9::List_::head;
    use crate::module_264daaf9::List_::isEmpty as isEmpty_1;
    use crate::module_264daaf9::List_::singleton as singleton_1;
    use crate::module_264daaf9::List_::tail;
    use crate::module_75c81ae2::Array_::fold as fold_1;
    use crate::module_912d02ed::Interfaces_::IEnumerable_1;
    use crate::module_9d52c5fc::Seq_::compareWith;
    use crate::module_9d52c5fc::Seq_::delay;
    use crate::module_9d52c5fc::Seq_::fold as fold_3;
    use crate::module_9d52c5fc::Seq_::unfold;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    pub mod SR {
        use super::*;
        use crate::module_2031347a::Native_::thread_local;
        use crate::module_2031347a::Native_::Lrc;
        use crate::module_c5a2a64e::String_::string;
        pub fn mapCannotBeMutated() -> Lrc<str> {
            thread_local! {
                static mapCannotBeMutated: Lrc<str> = string("Map values cannot be mutated.");
            };
            mapCannotBeMutated.with(|value| value.clone())
        }
        pub fn enumerationNotStarted() -> Lrc<str> {
            thread_local! {
                        static enumerationNotStarted: Lrc<str> =
            string("Enumeration has not started. Call MoveNext.");
                    };
            enumerationNotStarted.with(|value| value.clone())
        }
        pub fn enumerationAlreadyFinished() -> Lrc<str> {
            thread_local! {
                        static enumerationAlreadyFinished: Lrc<str> =
            string("Enumeration already finished.");
                    };
            enumerationAlreadyFinished.with(|value| value.clone())
        }
        pub fn keyNotFound() -> Lrc<str> {
            thread_local! {
                        static keyNotFound: Lrc<str> =
            string("The item, key, or index was not found in the collection.");
                    };
            keyNotFound.with(|value| value.clone())
        }
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct MapTree_2<K: Clone + 'static, V: Clone + 'static> {
        pub Height: i32,
        pub Key: K,
        pub Value: V,
        pub Left: Option<Lrc<Map_::MapTree_2<K, V>>>,
        pub Right: Option<Lrc<Map_::MapTree_2<K, V>>>,
    }
    pub fn empty<K: Clone + 'static, V: Clone + 'static>() -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        None::<Lrc<Map_::MapTree_2<K, V>>>
    }
    pub fn isEmpty<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        m.is_none()
    }
    pub fn mkMapTreeLeaf<K: Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        Some(Lrc::from(Map_::MapTree_2::<K, V> {
            Height: 1i32,
            Key: k,
            Value: v,
            Left: Map_::empty(),
            Right: Map_::empty(),
        }))
    }
    pub fn mkMapTreeNode<K: Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
        left: Option<Lrc<Map_::MapTree_2<K, V>>>,
        right: Option<Lrc<Map_::MapTree_2<K, V>>>,
        h: i32,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        Some(Lrc::from(Map_::MapTree_2::<K, V> {
            Height: h,
            Key: k,
            Value: v,
            Left: left,
            Right: right,
        }))
    }
    pub fn singleton<K: Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        Map_::mkMapTreeLeaf(k, v)
    }
    pub fn sizeAux<K: Clone + 'static, V: Clone + 'static>(
        acc: i32,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> i32 {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    acc + 1i32
                } else {
                    Map_::sizeAux(Map_::sizeAux(acc + 1i32, t.Left.clone()), t.Right.clone())
                }
            }
            _ => acc,
        }
    }
    pub fn count<_a: Clone + 'static, _b: Clone + 'static>(
        x: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> i32 {
        Map_::sizeAux(0i32, x)
    }
    pub fn height<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> i32 {
        match &m {
            Some(m_0_0) => m_0_0.Height,
            _ => 0i32,
        }
    }
    pub fn mk<K: Clone + 'static, V: Clone + 'static>(
        l: Option<Lrc<Map_::MapTree_2<K, V>>>,
        k: K,
        v: V,
        r: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        let hl: i32 = {
            let m: Option<Lrc<Map_::MapTree_2<K, V>>> = l.clone();
            match &m {
                Some(m_0_0) => m_0_0.Height,
                _ => 0i32,
            }
        };
        let hr: i32 = {
            let m_1: Option<Lrc<Map_::MapTree_2<K, V>>> = r.clone();
            match &m_1 {
                Some(m_1_0_0) => m_1_0_0.Height,
                _ => 0i32,
            }
        };
        let m_2: i32 = if hl < hr { hr } else { hl };
        if m_2 == 0i32 {
            Map_::mkMapTreeLeaf(k.clone(), v.clone())
        } else {
            Map_::mkMapTreeNode(k.clone(), v.clone(), l.clone(), r.clone(), m_2 + 1i32)
        }
    }
    pub fn rebalance<K: Clone + 'static, V: Clone + 'static>(
        t1: Option<Lrc<Map_::MapTree_2<K, V>>>,
        k: K,
        v: V,
        t2: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        let t1h: i32 = {
            let m: Option<Lrc<Map_::MapTree_2<K, V>>> = t1.clone();
            match &m {
                Some(m_0_0) => m_0_0.Height,
                _ => 0i32,
            }
        };
        let t2h: i32 = {
            let m_1: Option<Lrc<Map_::MapTree_2<K, V>>> = t2.clone();
            match &m_1 {
                Some(m_1_0_0) => m_1_0_0.Height,
                _ => 0i32,
            }
        };
        if t2h > t1h + 2i32 {
            let t2_: Lrc<Map_::MapTree_2<K, V>> = getValue(t2.clone()).clone();
            if {
                let m_2: Option<Lrc<Map_::MapTree_2<K, V>>> = t2_.Left.clone();
                match &m_2 {
                    Some(m_2_0_0) => m_2_0_0.Height,
                    _ => 0i32,
                }
            } > t1h + 1i32
            {
                let t2l: Lrc<Map_::MapTree_2<K, V>> = getValue(t2_.Left.clone()).clone();
                Map_::mk(
                    Map_::mk(t1.clone(), k.clone(), v.clone(), t2l.Left.clone()),
                    t2l.Key.clone(),
                    t2l.Value.clone(),
                    Map_::mk(
                        t2l.Right.clone(),
                        t2_.Key.clone(),
                        t2_.Value.clone(),
                        t2_.Right.clone(),
                    ),
                )
            } else {
                Map_::mk(
                    Map_::mk(t1.clone(), k.clone(), v.clone(), t2_.Left.clone()),
                    t2_.Key.clone(),
                    t2_.Value.clone(),
                    t2_.Right.clone(),
                )
            }
        } else {
            if t1h > t2h + 2i32 {
                let t1_: Lrc<Map_::MapTree_2<K, V>> = getValue(t1.clone()).clone();
                if {
                    let m_3: Option<Lrc<Map_::MapTree_2<K, V>>> = t1_.Right.clone();
                    match &m_3 {
                        Some(m_3_0_0) => m_3_0_0.Height,
                        _ => 0i32,
                    }
                } > t2h + 1i32
                {
                    let t1r: Lrc<Map_::MapTree_2<K, V>> = getValue(t1_.Right.clone()).clone();
                    Map_::mk(
                        Map_::mk(
                            t1_.Left.clone(),
                            t1_.Key.clone(),
                            t1_.Value.clone(),
                            t1r.Left.clone(),
                        ),
                        t1r.Key.clone(),
                        t1r.Value.clone(),
                        Map_::mk(t1r.Right.clone(), k.clone(), v.clone(), t2.clone()),
                    )
                } else {
                    Map_::mk(
                        t1_.Left.clone(),
                        t1_.Key.clone(),
                        t1_.Value.clone(),
                        Map_::mk(t1_.Right.clone(), k.clone(), v.clone(), t2.clone()),
                    )
                }
            } else {
                Map_::mk(t1.clone(), k.clone(), v.clone(), t2.clone())
            }
        }
    }
    pub fn add<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c < 0i32 {
                        Map_::mkMapTreeNode(k.clone(), v.clone(), Map_::empty(), m.clone(), 2i32)
                    } else {
                        if c == 0i32 {
                            Map_::mkMapTreeLeaf(k.clone(), v.clone())
                        } else {
                            Map_::mkMapTreeNode(
                                k.clone(),
                                v.clone(),
                                m.clone(),
                                Map_::empty(),
                                2i32,
                            )
                        }
                    }
                } else {
                    if c < 0i32 {
                        Map_::rebalance(
                            Map_::add(k.clone(), v.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            Map_::mkMapTreeNode(
                                k.clone(),
                                v.clone(),
                                t.Left.clone(),
                                t.Right.clone(),
                                t.Height,
                            )
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::add(k.clone(), v.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Map_::mkMapTreeLeaf(k.clone(), v.clone()),
        }
    }
    pub fn tryGetValue<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        v: &Lrc<MutCell<V>>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        let k: Lrc<MutCell<K>> = Lrc::from(MutCell::from(k.clone()));
        let m: Lrc<MutCell<Option<Lrc<Map_::MapTree_2<K, V>>>>> =
            Lrc::from(MutCell::from(m.clone()));
        '_tryGetValue: loop {
            break '_tryGetValue (match &m.get() {
                Some(m_0_0) => {
                    let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                    let c: i32 = compare(k.get().clone(), t.Key.clone());
                    if c == 0i32 {
                        v.set(t.Value.clone());
                        true
                    } else {
                        if t.Height == 1i32 {
                            false
                        } else {
                            let k_temp: K = k.get().clone();
                            let v_temp: V = v.get().clone();
                            let m_temp: Option<Lrc<Map_::MapTree_2<K, V>>> = if c < 0i32 {
                                t.Left.clone()
                            } else {
                                t.Right.clone()
                            };
                            k.set(k_temp);
                            v.set(v_temp);
                            m.set(m_temp);
                            continue '_tryGetValue;
                        }
                    }
                }
                _ => false,
            });
        }
    }
    pub fn throwKeyNotFound<_a: Clone + 'static>() -> _a {
        panic!("{}", Map_::SR::keyNotFound())
    }
    pub fn find<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> V {
        let v: Lrc<MutCell<V>> = Lrc::from(MutCell::from(defaultOf::<V>()));
        if Map_::tryGetValue(k, &v, m) {
            v.get().clone()
        } else {
            Map_::throwKeyNotFound()
        }
    }
    pub fn tryFind<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<V> {
        let v: Lrc<MutCell<V>> = Lrc::from(MutCell::from(defaultOf::<V>()));
        if Map_::tryGetValue(k, &v, m) {
            Some(v.get().clone())
        } else {
            None::<V>
        }
    }
    pub fn item<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> V {
        Map_::find(k, m)
    }
    pub fn partition1<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        k: _a,
        v: _b,
        acc1: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
        acc2: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Lrc<(
        Option<Lrc<Map_::MapTree_2<_a, _b>>>,
        Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    )> {
        if f(k.clone(), v.clone()) {
            Lrc::from((Map_::add(k.clone(), v.clone(), acc1.clone()), acc2.clone()))
        } else {
            Lrc::from((acc1.clone(), Map_::add(k.clone(), v.clone(), acc2.clone())))
        }
    }
    pub fn partitionAux<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
        acc_: Option<Lrc<Map_::MapTree_2<K, V>>>,
        acc__1: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<(
        Option<Lrc<Map_::MapTree_2<K, V>>>,
        Option<Lrc<Map_::MapTree_2<K, V>>>,
    )> {
        let acc: Lrc<(
            Option<Lrc<Map_::MapTree_2<K, V>>>,
            Option<Lrc<Map_::MapTree_2<K, V>>>,
        )> = Lrc::from((acc_, acc__1));
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    Map_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        t.Value.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    )
                } else {
                    let acc_3: Lrc<(
                        Option<Lrc<Map_::MapTree_2<K, V>>>,
                        Option<Lrc<Map_::MapTree_2<K, V>>>,
                    )> = Map_::partitionAux(
                        f.clone(),
                        t.Right.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    );
                    let acc_6: Lrc<(
                        Option<Lrc<Map_::MapTree_2<K, V>>>,
                        Option<Lrc<Map_::MapTree_2<K, V>>>,
                    )> = Map_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        t.Value.clone(),
                        acc_3.0.clone(),
                        acc_3.1.clone(),
                    );
                    Map_::partitionAux(f.clone(), t.Left.clone(), acc_6.0.clone(), acc_6.1.clone())
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn partition<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Lrc<(
        Option<Lrc<Map_::MapTree_2<_a, _b>>>,
        Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    )> {
        Map_::partitionAux(f, m, Map_::empty(), Map_::empty())
    }
    pub fn filter1<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        k: _a,
        v: _b,
        acc: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Option<Lrc<Map_::MapTree_2<_a, _b>>> {
        if f(k.clone(), v.clone()) {
            Map_::add(k.clone(), v.clone(), acc.clone())
        } else {
            acc.clone()
        }
    }
    pub fn filterAux<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
        acc: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    Map_::filter1(f.clone(), t.Key.clone(), t.Value.clone(), acc.clone())
                } else {
                    Map_::filterAux(
                        f.clone(),
                        t.Right.clone(),
                        Map_::filter1(
                            f.clone(),
                            t.Key.clone(),
                            t.Value.clone(),
                            Map_::filterAux(f.clone(), t.Left.clone(), acc.clone()),
                        ),
                    )
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn filter<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Option<Lrc<Map_::MapTree_2<_a, _b>>> {
        Map_::filterAux(f, m, Map_::empty())
    }
    pub fn spliceOutSuccessor<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<(K, V, Option<Lrc<Map_::MapTree_2<K, V>>>)> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    Lrc::from((t.Key.clone(), t.Value.clone(), Map_::empty()))
                } else {
                    if Map_::isEmpty(t.Left.clone()) {
                        Lrc::from((t.Key.clone(), t.Value.clone(), t.Right.clone()))
                    } else {
                        let patternInput: Lrc<(K, V, Option<Lrc<Map_::MapTree_2<K, V>>>)> =
                            Map_::spliceOutSuccessor(t.Left.clone());
                        Lrc::from((
                            patternInput.0.clone(),
                            patternInput.1.clone(),
                            Map_::mk(
                                patternInput.2.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                t.Right.clone(),
                            ),
                        ))
                    }
                }
            }
            _ => panic!("{}", string("internal error: Map.spliceOutSuccessor")),
        }
    }
    pub fn remove<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c == 0i32 {
                        Map_::empty()
                    } else {
                        m.clone()
                    }
                } else {
                    if c < 0i32 {
                        Map_::rebalance(
                            Map_::remove(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            if Map_::isEmpty(t.Left.clone()) {
                                t.Right.clone()
                            } else {
                                if Map_::isEmpty(t.Right.clone()) {
                                    t.Left.clone()
                                } else {
                                    let patternInput: Lrc<(
                                        K,
                                        V,
                                        Option<Lrc<Map_::MapTree_2<K, V>>>,
                                    )> = Map_::spliceOutSuccessor(t.Right.clone());
                                    Map_::mk(
                                        t.Left.clone(),
                                        patternInput.0.clone(),
                                        patternInput.1.clone(),
                                        patternInput.2.clone(),
                                    )
                                }
                            }
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::remove(k.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn change<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        u: Lrc<impl Fn(Option<V>) -> (Option<V>) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, V>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    let c: i32 = compare(k.clone(), t.Key.clone());
                    if c < 0i32 {
                        let matchValue_1: Option<V> = u(None::<V>);
                        match &matchValue_1 {
                            Some(matchValue_1_0_0) => Map_::mkMapTreeNode(
                                k.clone(),
                                matchValue_1_0_0.clone(),
                                Map_::empty(),
                                m.clone(),
                                2i32,
                            ),
                            _ => m.clone(),
                        }
                    } else {
                        if c == 0i32 {
                            let matchValue_2: Option<V> = u(Some(t.Value.clone()));
                            match &matchValue_2 {
                                Some(matchValue_2_0_0) => {
                                    Map_::mkMapTreeLeaf(k.clone(), matchValue_2_0_0.clone())
                                }
                                _ => Map_::empty(),
                            }
                        } else {
                            let matchValue_3: Option<V> = u(None::<V>);
                            match &matchValue_3 {
                                Some(matchValue_3_0_0) => Map_::mkMapTreeNode(
                                    k.clone(),
                                    matchValue_3_0_0.clone(),
                                    m.clone(),
                                    Map_::empty(),
                                    2i32,
                                ),
                                _ => m.clone(),
                            }
                        }
                    }
                } else {
                    let c_1: i32 = compare(k.clone(), t.Key.clone());
                    if c_1 < 0i32 {
                        Map_::rebalance(
                            Map_::change(k.clone(), u.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c_1 == 0i32 {
                            let matchValue_4: Option<V> = u(Some(t.Value.clone()));
                            match &matchValue_4 {
                                Some(matchValue_4_0_0) => Map_::mkMapTreeNode(
                                    k.clone(),
                                    matchValue_4_0_0.clone(),
                                    t.Left.clone(),
                                    t.Right.clone(),
                                    t.Height,
                                ),
                                _ => {
                                    if Map_::isEmpty(t.Left.clone()) {
                                        t.Right.clone()
                                    } else {
                                        if Map_::isEmpty(t.Right.clone()) {
                                            t.Left.clone()
                                        } else {
                                            let patternInput: Lrc<(
                                                K,
                                                V,
                                                Option<Lrc<Map_::MapTree_2<K, V>>>,
                                            )> = Map_::spliceOutSuccessor(t.Right.clone());
                                            Map_::mk(
                                                t.Left.clone(),
                                                patternInput.0.clone(),
                                                patternInput.1.clone(),
                                                patternInput.2.clone(),
                                            )
                                        }
                                    }
                                }
                            }
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::change(k.clone(), u.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => {
                let matchValue: Option<V> = u(None::<V>);
                match &matchValue {
                    Some(matchValue_0_0) => Map_::mkMapTreeLeaf(k.clone(), matchValue_0_0.clone()),
                    _ => m.clone(),
                }
            }
        }
    }
    pub fn containsKey<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        let k: Lrc<MutCell<K>> = Lrc::from(MutCell::from(k.clone()));
        let m: Lrc<MutCell<Option<Lrc<Map_::MapTree_2<K, V>>>>> =
            Lrc::from(MutCell::from(m.clone()));
        '_containsKey: loop {
            break '_containsKey (match &m.get() {
                Some(m_0_0) => {
                    let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                    let c: i32 = compare(k.get().clone(), t.Key.clone());
                    if t.Height == 1i32 {
                        c == 0i32
                    } else {
                        if c < 0i32 {
                            let k_temp: K = k.get().clone();
                            let m_temp: Option<Lrc<Map_::MapTree_2<K, V>>> = t.Left.clone();
                            k.set(k_temp);
                            m.set(m_temp);
                            continue '_containsKey;
                        } else {
                            if c == 0i32 {
                                true
                            } else {
                                let k_temp: K = k.get().clone();
                                let m_temp: Option<Lrc<Map_::MapTree_2<K, V>>> = t.Right.clone();
                                k.set(k_temp);
                                m.set(m_temp);
                                continue '_containsKey;
                            }
                        }
                    }
                }
                _ => false,
            });
        }
    }
    pub fn iterate<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    Map_::iterate(f.clone(), t.Left.clone());
                    f(t.Key.clone(), t.Value.clone());
                    Map_::iterate(f.clone(), t.Right.clone())
                }
            }
            _ => (),
        };
    }
    pub fn tryPick<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (Option<_a>) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<_a> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    let matchValue: Option<_a> = Map_::tryPick(f.clone(), t.Left.clone());
                    match &matchValue {
                        None => {
                            let matchValue_1: Option<_a> = f(t.Key.clone(), t.Value.clone());
                            match &matchValue_1 {
                                None => Map_::tryPick(f.clone(), t.Right.clone()),
                                _ => matchValue_1.clone(),
                            }
                        }
                        _ => matchValue.clone(),
                    }
                }
            }
            _ => None::<_a>,
        }
    }
    pub fn pick<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        chooser: Lrc<impl Fn(K, V) -> (Option<_a>) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> _a {
        let matchValue: Option<_a> = Map_::tryPick(chooser, m);
        match &matchValue {
            Some(matchValue_0_0) => matchValue_0_0.clone(),
            _ => Map_::throwKeyNotFound(),
        }
    }
    pub fn findKey<K: Clone + 'static, V: Clone + 'static>(
        predicate: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> K {
        Map_::pick(
            Lrc::from({
                let predicate = predicate.clone();
                move |k: K, v: V| {
                    if predicate(k.clone(), v.clone()) {
                        Some(k.clone())
                    } else {
                        None::<K>
                    }
                }
            }),
            m,
        )
    }
    pub fn tryFindKey<K: Clone + 'static, V: Clone + 'static>(
        predicate: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<K> {
        Map_::tryPick(
            Lrc::from({
                let predicate = predicate.clone();
                move |k: K, v: V| {
                    if predicate(k.clone(), v.clone()) {
                        Some(k.clone())
                    } else {
                        None::<K>
                    }
                }
            }),
            m,
        )
    }
    pub fn exists<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    if if Map_::exists(f.clone(), t.Left.clone()) {
                        true
                    } else {
                        f(t.Key.clone(), t.Value.clone())
                    } {
                        true
                    } else {
                        Map_::exists(f.clone(), t.Right.clone())
                    }
                }
            }
            _ => false,
        }
    }
    pub fn forAll<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    if if Map_::forAll(f.clone(), t.Left.clone()) {
                        f(t.Key.clone(), t.Value.clone())
                    } else {
                        false
                    } {
                        Map_::forAll(f.clone(), t.Right.clone())
                    } else {
                        false
                    }
                }
            }
            _ => true,
        }
    }
    pub fn mapRange<V: Clone + 'static, R: Clone + 'static, K: Clone + 'static>(
        f: Lrc<impl Fn(V) -> (R) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, R>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    Map_::mkMapTreeLeaf(t.Key.clone(), f(t.Value.clone()))
                } else {
                    let l2: Option<Lrc<Map_::MapTree_2<K, R>>> =
                        Map_::mapRange(f.clone(), t.Left.clone());
                    Map_::mkMapTreeNode(
                        t.Key.clone(),
                        f(t.Value.clone()),
                        l2,
                        Map_::mapRange(f.clone(), t.Right.clone()),
                        t.Height,
                    )
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn map<K: Clone + 'static, V: Clone + 'static, R: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (R) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Option<Lrc<Map_::MapTree_2<K, R>>> {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    Map_::mkMapTreeLeaf(t.Key.clone(), f(t.Key.clone(), t.Value.clone()))
                } else {
                    let l2: Option<Lrc<Map_::MapTree_2<K, R>>> =
                        Map_::map(f.clone(), t.Left.clone());
                    Map_::mkMapTreeNode(
                        t.Key.clone(),
                        f(t.Key.clone(), t.Value.clone()),
                        l2,
                        Map_::map(f.clone(), t.Right.clone()),
                        t.Height,
                    )
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn foldBack<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
        x: _a,
    ) -> _a {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone(), x.clone())
                } else {
                    Map_::foldBack(
                        f.clone(),
                        t.Left.clone(),
                        f(
                            t.Key.clone(),
                            t.Value.clone(),
                            Map_::foldBack(f.clone(), t.Right.clone(), x.clone()),
                        ),
                    )
                }
            }
            _ => x.clone(),
        }
    }
    pub fn fold<_a: Clone + 'static, K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(_a, K, V) -> (_a) + 'static>,
        x: _a,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> _a {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    f(x.clone(), t.Key.clone(), t.Value.clone())
                } else {
                    Map_::fold(
                        f.clone(),
                        f(
                            Map_::fold(f.clone(), x.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                        ),
                        t.Right.clone(),
                    )
                }
            }
            _ => x.clone(),
        }
    }
    pub fn foldFromTo<K: PartialOrd + Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        lo: K,
        hi: K,
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
        x: _a,
    ) -> _a {
        match &m {
            Some(m_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                if t.Height == 1i32 {
                    if if compare(lo.clone(), t.Key.clone()) <= 0i32 {
                        compare(t.Key.clone(), hi.clone()) <= 0i32
                    } else {
                        false
                    } {
                        f(t.Key.clone(), t.Value.clone(), x.clone())
                    } else {
                        x.clone()
                    }
                } else {
                    let cLoKey_1: i32 = compare(lo.clone(), t.Key.clone());
                    let cKeyHi_1: i32 = compare(t.Key.clone(), hi.clone());
                    let x_2: _a = if cLoKey_1 < 0i32 {
                        Map_::foldFromTo(
                            lo.clone(),
                            hi.clone(),
                            f.clone(),
                            t.Left.clone(),
                            x.clone(),
                        )
                    } else {
                        x.clone()
                    };
                    let x_3: _a = if if cLoKey_1 <= 0i32 {
                        cKeyHi_1 <= 0i32
                    } else {
                        false
                    } {
                        f(t.Key.clone(), t.Value.clone(), x_2.clone())
                    } else {
                        x_2.clone()
                    };
                    if cKeyHi_1 < 0i32 {
                        Map_::foldFromTo(
                            lo.clone(),
                            hi.clone(),
                            f.clone(),
                            t.Right.clone(),
                            x_3.clone(),
                        )
                    } else {
                        x_3.clone()
                    }
                }
            }
            _ => x.clone(),
        }
    }
    pub fn foldSection<K: PartialOrd + Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        lo: K,
        hi: K,
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
        x: _a,
    ) -> _a {
        if compare(lo.clone(), hi.clone()) == 1i32 {
            x.clone()
        } else {
            Map_::foldFromTo(lo.clone(), hi.clone(), f, m, x.clone())
        }
    }
    pub fn copyToArray<_a: Clone + 'static, _b: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
        arr: Lrc<MutCell<Vec<Lrc<(_a, _b)>>>>,
        i: i32,
    ) {
        let j: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
        Map_::iterate(
            Lrc::from({
                let arr = arr.clone();
                let j = j.clone();
                move |k: _a, v: _b| {
                    arr.get_mut()[j.get() as usize] = Lrc::from((k.clone(), v.clone()));
                    j.set(j.get() + 1i32)
                }
            }),
            m,
        )
    }
    pub fn keys<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<MutCell<Vec<K>>> {
        let res: Lrc<MutCell<Vec<K>>> = arrayWithCapacity::<K>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(k.clone())
            }),
            m.clone(),
        );
        res.clone()
    }
    pub fn values<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<MutCell<Vec<V>>> {
        let res: Lrc<MutCell<Vec<V>>> = arrayWithCapacity::<V>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(v.clone())
            }),
            m.clone(),
        );
        res.clone()
    }
    pub fn toArray<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<MutCell<Vec<Lrc<(K, V)>>>> {
        let res: Lrc<MutCell<Vec<Lrc<(K, V)>>>> =
            arrayWithCapacity::<Lrc<(K, V)>>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(Lrc::from((k.clone(), v.clone())))
            }),
            m.clone(),
        );
        res.clone()
    }
    pub fn toList<K: Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> List_1<Lrc<(K, V)>> {
        Map_::foldBack(
            Lrc::from(move |k: K, v: V, acc: List_1<Lrc<(K, V)>>| {
                cons(Lrc::from((k.clone(), v.clone())), acc.clone())
            }),
            m,
            empty_1::<Lrc<(K, V)>>(),
        )
    }
    pub fn ofArray<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: Lrc<MutCell<Vec<Lrc<(_a, _b)>>>>,
    ) -> Option<Lrc<Map_::MapTree_2<_a, _b>>> {
        fold_1(
            Lrc::from(
                move |acc: Option<Lrc<Map_::MapTree_2<_a, _b>>>, tupledArg: Lrc<(_a, _b)>| {
                    Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
                },
            ),
            Map_::empty(),
            xs,
        )
    }
    pub fn ofList<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: List_1<Lrc<(_a, _b)>>,
    ) -> Option<Lrc<Map_::MapTree_2<_a, _b>>> {
        fold_2(
            Lrc::from(
                move |acc: Option<Lrc<Map_::MapTree_2<_a, _b>>>, tupledArg: Lrc<(_a, _b)>| {
                    Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
                },
            ),
            Map_::empty(),
            xs,
        )
    }
    pub fn ofSeq<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: Lrc<dyn IEnumerable_1<Lrc<(_a, _b)>>>,
    ) -> Option<Lrc<Map_::MapTree_2<_a, _b>>> {
        fold_3(
            Lrc::from(
                move |acc: Option<Lrc<Map_::MapTree_2<_a, _b>>>, tupledArg: Lrc<(_a, _b)>| {
                    Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
                },
            ),
            Map_::empty(),
            xs,
        )
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct MapIterator_2<K: PartialOrd + Clone + 'static, V: Clone + 'static> {
        pub stack: MutCell<List_1<Option<Lrc<Map_::MapTree_2<K, V>>>>>,
        pub started: MutCell<bool>,
    }
    pub fn collapseLHS<K: Clone + 'static, V: Clone + 'static>(
        stack: List_1<Option<Lrc<Map_::MapTree_2<K, V>>>>,
    ) -> List_1<Option<Lrc<Map_::MapTree_2<K, V>>>> {
        let stack: Lrc<MutCell<List_1<Option<Lrc<Map_::MapTree_2<K, V>>>>>> =
            Lrc::from(MutCell::from(stack.clone()));
        '_collapseLHS: loop {
            break '_collapseLHS (if !isEmpty_1(stack.get().clone()) {
                let rest: List_1<Option<Lrc<Map_::MapTree_2<K, V>>>> =
                    tail(stack.get().clone()).clone();
                let m: Option<Lrc<Map_::MapTree_2<K, V>>> = head(stack.get().clone()).clone();
                match &m {
                    Some(m_0_0) => {
                        let t: Lrc<Map_::MapTree_2<K, V>> = m_0_0.clone();
                        if t.Height == 1i32 {
                            stack.get().clone()
                        } else {
                            let stack_temp: List_1<Option<Lrc<Map_::MapTree_2<K, V>>>> = cons(
                                t.Left.clone(),
                                cons(
                                    Map_::mkMapTreeLeaf(t.Key.clone(), t.Value.clone()),
                                    cons(t.Right.clone(), rest.clone()),
                                ),
                            );
                            stack.set(stack_temp);
                            continue '_collapseLHS;
                        }
                    }
                    _ => {
                        let stack_temp: List_1<Option<Lrc<Map_::MapTree_2<K, V>>>> = rest.clone();
                        stack.set(stack_temp);
                        continue '_collapseLHS;
                    }
                }
            } else {
                empty_1::<Option<Lrc<Map_::MapTree_2<K, V>>>>()
            });
        }
    }
    pub fn mkIterator<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Lrc<Map_::MapIterator_2<_a, _b>> {
        Lrc::from(Map_::MapIterator_2::<_a, _b> {
            stack: MutCell::from(Map_::collapseLHS(singleton_1(m))),
            started: MutCell::from(false),
        })
    }
    pub fn notStarted<_a: Clone + 'static>() -> _a {
        panic!("{}", Map_::SR::enumerationNotStarted())
    }
    pub fn alreadyFinished<_a: Clone + 'static>() -> _a {
        panic!("{}", Map_::SR::enumerationAlreadyFinished())
    }
    pub fn unexpectedStackForCurrent<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Map iterator, unexpected stack for current")
        )
    }
    pub fn unexpectedStackForMoveNext<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Map iterator, unexpected stack for moveNext")
        )
    }
    pub fn current<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        i: Lrc<Map_::MapIterator_2<_a, _b>>,
    ) -> Lrc<(_a, _b)> {
        if i.started.get() {
            let matchValue: List_1<Option<Lrc<Map_::MapTree_2<_a, _b>>>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).is_some() {
                    let t: Lrc<Map_::MapTree_2<_a, _b>> =
                        getValue(head(matchValue.clone()).clone()).clone();
                    if t.Height == 1i32 {
                        Lrc::from((t.Key.clone(), t.Value.clone()))
                    } else {
                        Map_::unexpectedStackForCurrent()
                    }
                } else {
                    Map_::alreadyFinished()
                }
            } else {
                Map_::alreadyFinished()
            }
        } else {
            Map_::notStarted()
        }
    }
    pub fn moveNext<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        i: Lrc<Map_::MapIterator_2<_a, _b>>,
    ) -> bool {
        if i.started.get() {
            let matchValue: List_1<Option<Lrc<Map_::MapTree_2<_a, _b>>>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).is_some() {
                    let t: Lrc<Map_::MapTree_2<_a, _b>> =
                        getValue(head(matchValue.clone()).clone()).clone();
                    if t.Height == 1i32 {
                        i.stack
                            .set(Map_::collapseLHS(tail(matchValue.clone()).clone()));
                        !isEmpty_1(i.stack.get().clone())
                    } else {
                        Map_::unexpectedStackForMoveNext()
                    }
                } else {
                    false
                }
            } else {
                false
            }
        } else {
            i.started.set(true);
            !isEmpty_1(i.stack.get().clone())
        }
    }
    pub fn toSeq<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        m: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> Lrc<dyn IEnumerable_1<Lrc<(K, V)>>> {
        delay(Lrc::from({
            let m = m.clone();
            move || {
                unfold(
                    Lrc::from(move |i: Lrc<Map_::MapIterator_2<K, V>>| {
                        if Map_::moveNext(i.clone()) {
                            Some(Lrc::from((Map_::current(i.clone()), i.clone())))
                        } else {
                            None::<Lrc<(Lrc<(K, V)>, Lrc<Map_::MapIterator_2<K, V>>)>>
                        }
                    }),
                    Map_::mkIterator(m.clone()),
                )
            }
        }))
    }
    pub fn compareTo<K: PartialOrd + Clone + 'static, V: PartialOrd + Clone + 'static>(
        m1: Option<Lrc<Map_::MapTree_2<K, V>>>,
        m2: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> i32 {
        compareWith(
            Lrc::from(move |e: Lrc<(K, V)>, e_1: Lrc<(K, V)>| compare(e.clone(), e_1.clone())),
            Map_::toSeq(m1),
            Map_::toSeq(m2),
        )
    }
    pub fn equals<K: PartialOrd + Clone + 'static, V: PartialOrd + Clone + 'static>(
        m1: Option<Lrc<Map_::MapTree_2<K, V>>>,
        m2: Option<Lrc<Map_::MapTree_2<K, V>>>,
    ) -> bool {
        Map_::compareTo(m1, m2) == 0i32
    }
}
