#![allow(dead_code)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(unused_attributes)]
pub mod Set_ {
    use super::*;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::List_1;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_264daaf9::List_::cons;
    use crate::module_264daaf9::List_::empty as empty_1;
    use crate::module_264daaf9::List_::fold as fold_3;
    use crate::module_264daaf9::List_::head;
    use crate::module_264daaf9::List_::isEmpty as isEmpty_1;
    use crate::module_264daaf9::List_::singleton as singleton_1;
    use crate::module_264daaf9::List_::tail;
    use crate::module_75c81ae2::Array_::fold as fold_2;
    use crate::module_912d02ed::Interfaces_::IEnumerable_1;
    use crate::module_9d52c5fc::Seq_::compareWith;
    use crate::module_9d52c5fc::Seq_::delay;
    use crate::module_9d52c5fc::Seq_::fold as fold_1;
    use crate::module_9d52c5fc::Seq_::reduce;
    use crate::module_9d52c5fc::Seq_::unfold;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    pub mod SR {
        use super::*;
        use crate::module_2031347a::Native_::thread_local;
        use crate::module_2031347a::Native_::Lrc;
        use crate::module_c5a2a64e::String_::string;
        pub fn setContainsNoElements() -> Lrc<str> {
            thread_local! {
                static setContainsNoElements: Lrc<str> = string("Set contains no elements.");
            };
            setContainsNoElements.with(|value| value.clone())
        }
        pub fn enumerationNotStarted() -> Lrc<str> {
            thread_local! {
                        static enumerationNotStarted: Lrc<str> =
            string("Enumeration has not started. Call MoveNext.");
                    };
            enumerationNotStarted.with(|value| value.clone())
        }
        pub fn enumerationAlreadyFinished() -> Lrc<str> {
            thread_local! {
                        static enumerationAlreadyFinished: Lrc<str> =
            string("Enumeration already finished.");
                    };
            enumerationAlreadyFinished.with(|value| value.clone())
        }
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct SetTree_1<T: Clone + 'static> {
        pub Height: i32,
        pub Key: T,
        pub Left: Option<Lrc<Set_::SetTree_1<T>>>,
        pub Right: Option<Lrc<Set_::SetTree_1<T>>>,
    }
    pub fn empty<T: Clone + 'static>() -> Option<Lrc<Set_::SetTree_1<T>>> {
        None::<Lrc<Set_::SetTree_1<T>>>
    }
    pub fn isEmpty<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> bool {
        s.is_none()
    }
    pub fn mkSetTreeLeaf<T: Clone + 'static>(key: T) -> Option<Lrc<Set_::SetTree_1<T>>> {
        Some(Lrc::from(Set_::SetTree_1::<T> {
            Height: 1i32,
            Key: key,
            Left: Set_::empty(),
            Right: Set_::empty(),
        }))
    }
    pub fn mkSetTreeNode<T: Clone + 'static>(
        key: T,
        left: Option<Lrc<Set_::SetTree_1<T>>>,
        right: Option<Lrc<Set_::SetTree_1<T>>>,
        height: i32,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        Some(Lrc::from(Set_::SetTree_1::<T> {
            Height: height,
            Key: key,
            Left: left,
            Right: right,
        }))
    }
    pub fn singleton<T: Clone + 'static>(value: T) -> Option<Lrc<Set_::SetTree_1<T>>> {
        Set_::mkSetTreeLeaf(value)
    }
    pub fn countAux<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>, acc: i32) -> i32 {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    acc + 1i32
                } else {
                    Set_::countAux(t.Left.clone(), Set_::countAux(t.Right.clone(), acc + 1i32))
                }
            }
            _ => acc,
        }
    }
    pub fn count<_a: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<_a>>>) -> i32 {
        Set_::countAux(s, 0i32)
    }
    pub fn height<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> i32 {
        match &s {
            Some(s_0_0) => s_0_0.Height,
            _ => 0i32,
        }
    }
    pub fn mk<T: Clone + 'static>(
        l: Option<Lrc<Set_::SetTree_1<T>>>,
        k: T,
        r: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        let hl: i32 = {
            let s: Option<Lrc<Set_::SetTree_1<T>>> = l.clone();
            match &s {
                Some(s_0_0) => s_0_0.Height,
                _ => 0i32,
            }
        };
        let hr: i32 = {
            let s_1: Option<Lrc<Set_::SetTree_1<T>>> = r.clone();
            match &s_1 {
                Some(s_1_0_0) => s_1_0_0.Height,
                _ => 0i32,
            }
        };
        let m: i32 = if hl < hr { hr } else { hl };
        if m == 0i32 {
            Set_::mkSetTreeLeaf(k.clone())
        } else {
            Set_::mkSetTreeNode(k.clone(), l.clone(), r.clone(), m + 1i32)
        }
    }
    pub fn rebalance<T: Clone + 'static>(
        t1: Option<Lrc<Set_::SetTree_1<T>>>,
        v: T,
        t2: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        let t1h: i32 = {
            let s: Option<Lrc<Set_::SetTree_1<T>>> = t1.clone();
            match &s {
                Some(s_0_0) => s_0_0.Height,
                _ => 0i32,
            }
        };
        let t2h: i32 = {
            let s_1: Option<Lrc<Set_::SetTree_1<T>>> = t2.clone();
            match &s_1 {
                Some(s_1_0_0) => s_1_0_0.Height,
                _ => 0i32,
            }
        };
        if t2h > t1h + 2i32 {
            let t2_: Lrc<Set_::SetTree_1<T>> = getValue(t2.clone()).clone();
            if {
                let s_2: Option<Lrc<Set_::SetTree_1<T>>> = t2_.Left.clone();
                match &s_2 {
                    Some(s_2_0_0) => s_2_0_0.Height,
                    _ => 0i32,
                }
            } > t1h + 1i32
            {
                let t2l: Lrc<Set_::SetTree_1<T>> = getValue(t2_.Left.clone()).clone();
                Set_::mk(
                    Set_::mk(t1.clone(), v.clone(), t2l.Left.clone()),
                    t2l.Key.clone(),
                    Set_::mk(t2l.Right.clone(), t2_.Key.clone(), t2_.Right.clone()),
                )
            } else {
                Set_::mk(
                    Set_::mk(t1.clone(), v.clone(), t2_.Left.clone()),
                    t2_.Key.clone(),
                    t2_.Right.clone(),
                )
            }
        } else {
            if t1h > t2h + 2i32 {
                let t1_: Lrc<Set_::SetTree_1<T>> = getValue(t1.clone()).clone();
                if {
                    let s_3: Option<Lrc<Set_::SetTree_1<T>>> = t1_.Right.clone();
                    match &s_3 {
                        Some(s_3_0_0) => s_3_0_0.Height,
                        _ => 0i32,
                    }
                } > t2h + 1i32
                {
                    let t1r: Lrc<Set_::SetTree_1<T>> = getValue(t1_.Right.clone()).clone();
                    Set_::mk(
                        Set_::mk(t1_.Left.clone(), t1_.Key.clone(), t1r.Left.clone()),
                        t1r.Key.clone(),
                        Set_::mk(t1r.Right.clone(), v.clone(), t2.clone()),
                    )
                } else {
                    Set_::mk(
                        t1_.Left.clone(),
                        t1_.Key.clone(),
                        Set_::mk(t1_.Right.clone(), v.clone(), t2.clone()),
                    )
                }
            } else {
                Set_::mk(t1.clone(), v.clone(), t2.clone())
            }
        }
    }
    pub fn add<T: PartialOrd + Clone + 'static>(
        k: T,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c < 0i32 {
                        Set_::mkSetTreeNode(k.clone(), Set_::empty(), s.clone(), 2i32)
                    } else {
                        if c == 0i32 {
                            s.clone()
                        } else {
                            Set_::mkSetTreeNode(k.clone(), s.clone(), Set_::empty(), 2i32)
                        }
                    }
                } else {
                    if c < 0i32 {
                        Set_::rebalance(
                            Set_::add(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            s.clone()
                        } else {
                            Set_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                Set_::add(k.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Set_::mkSetTreeLeaf(k.clone()),
        }
    }
    pub fn balance<T: PartialOrd + Clone + 'static>(
        s1: Option<Lrc<Set_::SetTree_1<T>>>,
        k: T,
        s2: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s1 {
            Some(s1_0_0) => {
                let t1: Lrc<Set_::SetTree_1<T>> = s1_0_0.clone();
                match &s2 {
                    Some(s2_0_0) => {
                        let t2: Lrc<Set_::SetTree_1<T>> = s2_0_0.clone();
                        if t1.Height == 1i32 {
                            Set_::add(k.clone(), Set_::add(t1.Key.clone(), s2.clone()))
                        } else {
                            if t2.Height == 1i32 {
                                Set_::add(k.clone(), Set_::add(t2.Key.clone(), s1.clone()))
                            } else {
                                if t1.Height + 2i32 < t2.Height {
                                    Set_::rebalance(
                                        Set_::balance(s1.clone(), k.clone(), t2.Left.clone()),
                                        t2.Key.clone(),
                                        t2.Right.clone(),
                                    )
                                } else {
                                    if t2.Height + 2i32 < t1.Height {
                                        Set_::rebalance(
                                            t1.Left.clone(),
                                            t1.Key.clone(),
                                            Set_::balance(t1.Right.clone(), k.clone(), s2.clone()),
                                        )
                                    } else {
                                        Set_::mk(s1.clone(), k.clone(), s2.clone())
                                    }
                                }
                            }
                        }
                    }
                    _ => Set_::add(k.clone(), s1.clone()),
                }
            }
            _ => Set_::add(k.clone(), s2.clone()),
        }
    }
    pub fn split<T: PartialOrd + Clone + 'static>(
        pivot: T,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Lrc<(
        Option<Lrc<Set_::SetTree_1<T>>>,
        bool,
        Option<Lrc<Set_::SetTree_1<T>>>,
    )> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    let c: i32 = compare(t.Key.clone(), pivot.clone());
                    if c < 0i32 {
                        Lrc::from((s.clone(), false, Set_::empty()))
                    } else {
                        if c == 0i32 {
                            Lrc::from((Set_::empty(), true, Set_::empty()))
                        } else {
                            Lrc::from((Set_::empty(), false, s.clone()))
                        }
                    }
                } else {
                    let c_1: i32 = compare(pivot.clone(), t.Key.clone());
                    if c_1 < 0i32 {
                        let patternInput: Lrc<(
                            Option<Lrc<Set_::SetTree_1<T>>>,
                            bool,
                            Option<Lrc<Set_::SetTree_1<T>>>,
                        )> = Set_::split(pivot.clone(), t.Left.clone());
                        Lrc::from((
                            patternInput.0.clone(),
                            patternInput.1.clone(),
                            Set_::balance(patternInput.2.clone(), t.Key.clone(), t.Right.clone()),
                        ))
                    } else {
                        if c_1 == 0i32 {
                            Lrc::from((t.Left.clone(), true, t.Right.clone()))
                        } else {
                            let patternInput_1: Lrc<(
                                Option<Lrc<Set_::SetTree_1<T>>>,
                                bool,
                                Option<Lrc<Set_::SetTree_1<T>>>,
                            )> = Set_::split(pivot.clone(), t.Right.clone());
                            Lrc::from((
                                Set_::balance(
                                    t.Left.clone(),
                                    t.Key.clone(),
                                    patternInput_1.0.clone(),
                                ),
                                patternInput_1.1.clone(),
                                patternInput_1.2.clone(),
                            ))
                        }
                    }
                }
            }
            _ => Lrc::from((Set_::empty(), false, Set_::empty())),
        }
    }
    pub fn spliceOutSuccessor<T: Clone + 'static>(
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Lrc<(T, Option<Lrc<Set_::SetTree_1<T>>>)> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    Lrc::from((t.Key.clone(), Set_::empty()))
                } else {
                    if Set_::isEmpty(t.Left.clone()) {
                        Lrc::from((t.Key.clone(), t.Right.clone()))
                    } else {
                        let patternInput: Lrc<(T, Option<Lrc<Set_::SetTree_1<T>>>)> =
                            Set_::spliceOutSuccessor(t.Left.clone());
                        Lrc::from((
                            patternInput.0.clone(),
                            Set_::mk(patternInput.1.clone(), t.Key.clone(), t.Right.clone()),
                        ))
                    }
                }
            }
            _ => panic!("{}", string("internal error: Set.spliceOutSuccessor")),
        }
    }
    pub fn remove<T: PartialOrd + Clone + 'static>(
        k: T,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c == 0i32 {
                        Set_::empty()
                    } else {
                        s.clone()
                    }
                } else {
                    if c < 0i32 {
                        Set_::rebalance(
                            Set_::remove(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            if Set_::isEmpty(t.Left.clone()) {
                                t.Right.clone()
                            } else {
                                if Set_::isEmpty(t.Right.clone()) {
                                    t.Left.clone()
                                } else {
                                    let patternInput: Lrc<(T, Option<Lrc<Set_::SetTree_1<T>>>)> =
                                        Set_::spliceOutSuccessor(t.Right.clone());
                                    Set_::mk(
                                        t.Left.clone(),
                                        patternInput.0.clone(),
                                        patternInput.1.clone(),
                                    )
                                }
                            }
                        } else {
                            Set_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                Set_::remove(k.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => s.clone(),
        }
    }
    pub fn contains<T: PartialOrd + Clone + 'static>(
        k: T,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> bool {
        let k: Lrc<MutCell<T>> = Lrc::from(MutCell::from(k.clone()));
        let s: Lrc<MutCell<Option<Lrc<Set_::SetTree_1<T>>>>> = Lrc::from(MutCell::from(s.clone()));
        '_contains: loop {
            break '_contains (match &s.get() {
                Some(s_0_0) => {
                    let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                    let c: i32 = compare(k.get().clone(), t.Key.clone());
                    if t.Height == 1i32 {
                        c == 0i32
                    } else {
                        if c < 0i32 {
                            let k_temp: T = k.get().clone();
                            let s_temp: Option<Lrc<Set_::SetTree_1<T>>> = t.Left.clone();
                            k.set(k_temp);
                            s.set(s_temp);
                            continue '_contains;
                        } else {
                            if c == 0i32 {
                                true
                            } else {
                                let k_temp: T = k.get().clone();
                                let s_temp: Option<Lrc<Set_::SetTree_1<T>>> = t.Right.clone();
                                k.set(k_temp);
                                s.set(s_temp);
                                continue '_contains;
                            }
                        }
                    }
                }
                _ => false,
            });
        }
    }
    pub fn iterate<T: Clone + 'static>(
        f: Lrc<impl Fn(T) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    Set_::iterate(f.clone(), t.Left.clone());
                    f(t.Key.clone());
                    Set_::iterate(f.clone(), t.Right.clone())
                }
            }
            _ => (),
        };
    }
    pub fn foldBack<T: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<impl Fn(T, _a) -> (_a) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
        x: _a,
    ) -> _a {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), x.clone())
                } else {
                    Set_::foldBack(
                        f.clone(),
                        t.Left.clone(),
                        f(
                            t.Key.clone(),
                            Set_::foldBack(f.clone(), t.Right.clone(), x.clone()),
                        ),
                    )
                }
            }
            _ => x.clone(),
        }
    }
    pub fn fold<_a: Clone + 'static, T: Clone + 'static>(
        f: Lrc<impl Fn(_a, T) -> (_a) + 'static>,
        x: _a,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> _a {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    f(x.clone(), t.Key.clone())
                } else {
                    Set_::fold(
                        f.clone(),
                        f(
                            Set_::fold(f.clone(), x.clone(), t.Left.clone()),
                            t.Key.clone(),
                        ),
                        t.Right.clone(),
                    )
                }
            }
            _ => x.clone(),
        }
    }
    pub fn map<T: Clone + 'static, _a: PartialOrd + Clone + 'static>(
        mapping: Lrc<impl Fn(T) -> (_a) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        Set_::fold(
            Lrc::from({
                let mapping = mapping.clone();
                move |acc: Option<Lrc<Set_::SetTree_1<_a>>>, k: T| {
                    Set_::add(mapping(k.clone()), acc.clone())
                }
            }),
            Set_::empty(),
            s,
        )
    }
    pub fn forAll<T: Clone + 'static>(
        f: Lrc<impl Fn(T) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> bool {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    if if f(t.Key.clone()) {
                        Set_::forAll(f.clone(), t.Left.clone())
                    } else {
                        false
                    } {
                        Set_::forAll(f.clone(), t.Right.clone())
                    } else {
                        false
                    }
                }
            }
            _ => true,
        }
    }
    pub fn exists<T: Clone + 'static>(
        f: Lrc<impl Fn(T) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> bool {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone())
                } else {
                    if if f(t.Key.clone()) {
                        true
                    } else {
                        Set_::exists(f.clone(), t.Left.clone())
                    } {
                        true
                    } else {
                        Set_::exists(f.clone(), t.Right.clone())
                    }
                }
            }
            _ => false,
        }
    }
    pub fn isSubset<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> bool {
        Set_::forAll(
            Lrc::from({
                let b = b.clone();
                move |x: _a| Set_::contains(x.clone(), b.clone())
            }),
            a,
        )
    }
    pub fn isSuperset<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> bool {
        Set_::isSubset(b, a)
    }
    pub fn isProperSubset<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> bool {
        if Set_::forAll(
            Lrc::from({
                let b = b.clone();
                move |x: _a| Set_::contains(x.clone(), b.clone())
            }),
            a.clone(),
        ) {
            Set_::exists(
                Lrc::from({
                    let a = a.clone();
                    move |x_1: _a| !Set_::contains(x_1.clone(), a.clone())
                }),
                b.clone(),
            )
        } else {
            false
        }
    }
    pub fn isProperSuperset<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> bool {
        Set_::isProperSubset(b, a)
    }
    pub fn filterAux<T: PartialOrd + Clone + 'static>(
        f: Lrc<impl Fn(T) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
        acc: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    if f(t.Key.clone()) {
                        Set_::add(t.Key.clone(), acc.clone())
                    } else {
                        acc.clone()
                    }
                } else {
                    Set_::filterAux(
                        f.clone(),
                        t.Left.clone(),
                        Set_::filterAux(
                            f.clone(),
                            t.Right.clone(),
                            if f(t.Key.clone()) {
                                Set_::add(t.Key.clone(), acc.clone())
                            } else {
                                acc.clone()
                            },
                        ),
                    )
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn filter<_a: PartialOrd + Clone + 'static>(
        f: Lrc<impl Fn(_a) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        Set_::filterAux(f, s, Set_::empty())
    }
    pub fn diffAux<T: PartialOrd + Clone + 'static>(
        s: Option<Lrc<Set_::SetTree_1<T>>>,
        acc: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &acc {
            Some(acc_0_0) => {
                let _acc: Lrc<Set_::SetTree_1<T>> = acc_0_0.clone();
                match &s {
                    Some(s_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                        if t.Height == 1i32 {
                            Set_::remove(t.Key.clone(), acc.clone())
                        } else {
                            Set_::diffAux(
                                t.Left.clone(),
                                Set_::diffAux(
                                    t.Right.clone(),
                                    Set_::remove(t.Key.clone(), acc.clone()),
                                ),
                            )
                        }
                    }
                    _ => acc.clone(),
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn difference<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        Set_::diffAux(b, a)
    }
    pub fn r#union<T: PartialOrd + Clone + 'static>(
        s1: Option<Lrc<Set_::SetTree_1<T>>>,
        s2: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s1 {
            Some(s1_0_0) => {
                let t1: Lrc<Set_::SetTree_1<T>> = s1_0_0.clone();
                match &s2 {
                    Some(s2_0_0) => {
                        let t2: Lrc<Set_::SetTree_1<T>> = s2_0_0.clone();
                        if t1.Height == 1i32 {
                            Set_::add(t1.Key.clone(), s2.clone())
                        } else {
                            if t2.Height == 1i32 {
                                Set_::add(t2.Key.clone(), s1.clone())
                            } else {
                                if t1.Height > t2.Height {
                                    let patternInput: Lrc<(
                                        Option<Lrc<Set_::SetTree_1<T>>>,
                                        bool,
                                        Option<Lrc<Set_::SetTree_1<T>>>,
                                    )> = Set_::split(t1.Key.clone(), s2.clone());
                                    Set_::balance(
                                        Set_::r#union(t1.Left.clone(), patternInput.0.clone()),
                                        t1.Key.clone(),
                                        Set_::r#union(t1.Right.clone(), patternInput.2.clone()),
                                    )
                                } else {
                                    let patternInput_1: Lrc<(
                                        Option<Lrc<Set_::SetTree_1<T>>>,
                                        bool,
                                        Option<Lrc<Set_::SetTree_1<T>>>,
                                    )> = Set_::split(t2.Key.clone(), s1.clone());
                                    Set_::balance(
                                        Set_::r#union(t2.Left.clone(), patternInput_1.0.clone()),
                                        t2.Key.clone(),
                                        Set_::r#union(t2.Right.clone(), patternInput_1.2.clone()),
                                    )
                                }
                            }
                        }
                    }
                    _ => s1.clone(),
                }
            }
            _ => s2.clone(),
        }
    }
    pub fn unionMany<T: PartialOrd + Clone + 'static>(
        sets: Lrc<dyn IEnumerable_1<Option<Lrc<Set_::SetTree_1<T>>>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        fold_1(
            Lrc::from(
                move |s: Option<Lrc<Set_::SetTree_1<T>>>, s_1: Option<Lrc<Set_::SetTree_1<T>>>| {
                    Set_::r#union(s.clone(), s_1.clone())
                },
            ),
            Set_::empty(),
            sets,
        )
    }
    pub fn intersectionAux<T: PartialOrd + Clone + 'static>(
        b: Option<Lrc<Set_::SetTree_1<T>>>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
        acc: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    if Set_::contains(t.Key.clone(), b.clone()) {
                        Set_::add(t.Key.clone(), acc.clone())
                    } else {
                        acc.clone()
                    }
                } else {
                    let acc_1: Option<Lrc<Set_::SetTree_1<T>>> =
                        Set_::intersectionAux(b.clone(), t.Right.clone(), acc.clone());
                    Set_::intersectionAux(
                        b.clone(),
                        t.Left.clone(),
                        if Set_::contains(t.Key.clone(), b.clone()) {
                            Set_::add(t.Key.clone(), acc_1.clone())
                        } else {
                            acc_1.clone()
                        },
                    )
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn intersect<_a: PartialOrd + Clone + 'static>(
        a: Option<Lrc<Set_::SetTree_1<_a>>>,
        b: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        if Set_::isEmpty(b.clone()) {
            b.clone()
        } else {
            Set_::intersectionAux(b.clone(), a, Set_::empty())
        }
    }
    pub fn intersectMany<T: PartialOrd + Clone + 'static>(
        sets: Lrc<dyn IEnumerable_1<Option<Lrc<Set_::SetTree_1<T>>>>>,
    ) -> Option<Lrc<Set_::SetTree_1<T>>> {
        reduce(
            Lrc::from(
                move |a: Option<Lrc<Set_::SetTree_1<T>>>, b: Option<Lrc<Set_::SetTree_1<T>>>| {
                    Set_::intersect(a.clone(), b.clone())
                },
            ),
            sets,
        )
    }
    pub fn partition1<_a: PartialOrd + Clone + 'static>(
        f: Lrc<impl Fn(_a) -> (bool) + 'static>,
        k: _a,
        acc1: Option<Lrc<Set_::SetTree_1<_a>>>,
        acc2: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Lrc<(
        Option<Lrc<Set_::SetTree_1<_a>>>,
        Option<Lrc<Set_::SetTree_1<_a>>>,
    )> {
        if f(k.clone()) {
            Lrc::from((Set_::add(k.clone(), acc1.clone()), acc2.clone()))
        } else {
            Lrc::from((acc1.clone(), Set_::add(k.clone(), acc2.clone())))
        }
    }
    pub fn partitionAux<T: PartialOrd + Clone + 'static>(
        f: Lrc<impl Fn(T) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<T>>>,
        acc_: Option<Lrc<Set_::SetTree_1<T>>>,
        acc__1: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Lrc<(
        Option<Lrc<Set_::SetTree_1<T>>>,
        Option<Lrc<Set_::SetTree_1<T>>>,
    )> {
        let acc: Lrc<(
            Option<Lrc<Set_::SetTree_1<T>>>,
            Option<Lrc<Set_::SetTree_1<T>>>,
        )> = Lrc::from((acc_, acc__1));
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    Set_::partition1(f.clone(), t.Key.clone(), acc.0.clone(), acc.1.clone())
                } else {
                    let acc_3: Lrc<(
                        Option<Lrc<Set_::SetTree_1<T>>>,
                        Option<Lrc<Set_::SetTree_1<T>>>,
                    )> = Set_::partitionAux(
                        f.clone(),
                        t.Right.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    );
                    let acc_6: Lrc<(
                        Option<Lrc<Set_::SetTree_1<T>>>,
                        Option<Lrc<Set_::SetTree_1<T>>>,
                    )> = Set_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        acc_3.0.clone(),
                        acc_3.1.clone(),
                    );
                    Set_::partitionAux(f.clone(), t.Left.clone(), acc_6.0.clone(), acc_6.1.clone())
                }
            }
            _ => acc.clone(),
        }
    }
    pub fn partition<_a: PartialOrd + Clone + 'static>(
        f: Lrc<impl Fn(_a) -> (bool) + 'static>,
        s: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Lrc<(
        Option<Lrc<Set_::SetTree_1<_a>>>,
        Option<Lrc<Set_::SetTree_1<_a>>>,
    )> {
        Set_::partitionAux(f, s, Set_::empty(), Set_::empty())
    }
    pub fn minimumElementAux<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>, n: T) -> T {
        let s: Lrc<MutCell<Option<Lrc<Set_::SetTree_1<T>>>>> = Lrc::from(MutCell::from(s.clone()));
        let n: Lrc<MutCell<T>> = Lrc::from(MutCell::from(n));
        '_minimumElementAux: loop {
            break '_minimumElementAux (match &s.get() {
                Some(s_0_0) => {
                    let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                    if t.Height == 1i32 {
                        t.Key.clone()
                    } else {
                        let s_temp: Option<Lrc<Set_::SetTree_1<T>>> = t.Left.clone();
                        let n_temp: T = t.Key.clone();
                        s.set(s_temp);
                        n.set(n_temp);
                        continue '_minimumElementAux;
                    }
                }
                _ => n.get().clone(),
            });
        }
    }
    pub fn minimumElementOpt<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> Option<T> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    Some(t.Key.clone())
                } else {
                    Some(Set_::minimumElementAux(t.Left.clone(), t.Key.clone()))
                }
            }
            _ => None::<T>,
        }
    }
    pub fn maximumElementAux<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>, n: T) -> T {
        let s: Lrc<MutCell<Option<Lrc<Set_::SetTree_1<T>>>>> = Lrc::from(MutCell::from(s.clone()));
        let n: Lrc<MutCell<T>> = Lrc::from(MutCell::from(n));
        '_maximumElementAux: loop {
            break '_maximumElementAux (match &s.get() {
                Some(s_0_0) => {
                    let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                    if t.Height == 1i32 {
                        t.Key.clone()
                    } else {
                        let s_temp: Option<Lrc<Set_::SetTree_1<T>>> = t.Right.clone();
                        let n_temp: T = t.Key.clone();
                        s.set(s_temp);
                        n.set(n_temp);
                        continue '_maximumElementAux;
                    }
                }
                _ => n.get().clone(),
            });
        }
    }
    pub fn maximumElementOpt<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> Option<T> {
        match &s {
            Some(s_0_0) => {
                let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                if t.Height == 1i32 {
                    Some(t.Key.clone())
                } else {
                    Some(Set_::maximumElementAux(t.Right.clone(), t.Key.clone()))
                }
            }
            _ => None::<T>,
        }
    }
    pub fn minElement<_a: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<_a>>>) -> _a {
        let matchValue: Option<_a> = Set_::minimumElementOpt(s);
        match &matchValue {
            None => panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Set_::SR::setContainsNoElements().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("s")
                ) as Lrc<str>
            ),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    pub fn maxElement<_a: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<_a>>>) -> _a {
        let matchValue: Option<_a> = Set_::maximumElementOpt(s);
        match &matchValue {
            None => panic!(
                "{}",
                Lrc::from(
                    (Lrc::from(
                        Set_::SR::setContainsNoElements().to_string()
                            + &string("\\nParameter name: ")
                    ) as Lrc<str>)
                        .to_string()
                        + &string("s")
                ) as Lrc<str>
            ),
            Some(matchValue_0_0) => matchValue_0_0.clone(),
        }
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct SetIterator_1<T: PartialOrd + Clone + 'static> {
        pub stack: MutCell<List_1<Option<Lrc<Set_::SetTree_1<T>>>>>,
        pub started: MutCell<bool>,
    }
    pub fn collapseLHS<T: Clone + 'static>(
        stack: List_1<Option<Lrc<Set_::SetTree_1<T>>>>,
    ) -> List_1<Option<Lrc<Set_::SetTree_1<T>>>> {
        let stack: Lrc<MutCell<List_1<Option<Lrc<Set_::SetTree_1<T>>>>>> =
            Lrc::from(MutCell::from(stack.clone()));
        '_collapseLHS: loop {
            break '_collapseLHS (if !isEmpty_1(stack.get().clone()) {
                let s: Option<Lrc<Set_::SetTree_1<T>>> = head(stack.get().clone()).clone();
                let rest: List_1<Option<Lrc<Set_::SetTree_1<T>>>> =
                    tail(stack.get().clone()).clone();
                match &s {
                    Some(s_0_0) => {
                        let t: Lrc<Set_::SetTree_1<T>> = s_0_0.clone();
                        if t.Height == 1i32 {
                            stack.get().clone()
                        } else {
                            let stack_temp: List_1<Option<Lrc<Set_::SetTree_1<T>>>> = cons(
                                t.Left.clone(),
                                cons(
                                    Set_::mkSetTreeLeaf(t.Key.clone()),
                                    cons(t.Right.clone(), rest.clone()),
                                ),
                            );
                            stack.set(stack_temp);
                            continue '_collapseLHS;
                        }
                    }
                    _ => {
                        let stack_temp: List_1<Option<Lrc<Set_::SetTree_1<T>>>> = rest.clone();
                        stack.set(stack_temp);
                        continue '_collapseLHS;
                    }
                }
            } else {
                empty_1::<Option<Lrc<Set_::SetTree_1<T>>>>()
            });
        }
    }
    pub fn mkIterator<_a: PartialOrd + Clone + 'static>(
        s: Option<Lrc<Set_::SetTree_1<_a>>>,
    ) -> Lrc<Set_::SetIterator_1<_a>> {
        Lrc::from(Set_::SetIterator_1::<_a> {
            stack: MutCell::from(Set_::collapseLHS(singleton_1(s))),
            started: MutCell::from(false),
        })
    }
    pub fn notStarted<_a: Clone + 'static>() -> _a {
        panic!("{}", Set_::SR::enumerationNotStarted())
    }
    pub fn alreadyFinished<_a: Clone + 'static>() -> _a {
        panic!("{}", Set_::SR::enumerationAlreadyFinished())
    }
    pub fn current<T: PartialOrd + Clone + 'static>(i: Lrc<Set_::SetIterator_1<T>>) -> T {
        if i.started.get() {
            let matchValue: List_1<Option<Lrc<Set_::SetTree_1<T>>>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).is_some() {
                    let k: Lrc<Set_::SetTree_1<T>> =
                        getValue(head(matchValue.clone()).clone()).clone();
                    k.Key.clone()
                } else {
                    Set_::alreadyFinished()
                }
            } else {
                Set_::alreadyFinished()
            }
        } else {
            Set_::notStarted()
        }
    }
    pub fn unexpectedStackForMoveNext<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Set iterator, unexpected stack for moveNext")
        )
    }
    pub fn unexpectedstateInSetTreeCompareStacks<_a: Clone + 'static>() -> _a {
        panic!("{}", string("unexpected state in SetTree.compareStacks"))
    }
    pub fn moveNext<T: PartialOrd + Clone + 'static>(i: Lrc<Set_::SetIterator_1<T>>) -> bool {
        if i.started.get() {
            let matchValue: List_1<Option<Lrc<Set_::SetTree_1<T>>>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).is_some() {
                    let t: Lrc<Set_::SetTree_1<T>> =
                        getValue(head(matchValue.clone()).clone()).clone();
                    if t.Height == 1i32 {
                        i.stack
                            .set(Set_::collapseLHS(tail(matchValue.clone()).clone()));
                        !isEmpty_1(i.stack.get().clone())
                    } else {
                        Set_::unexpectedStackForMoveNext()
                    }
                } else {
                    false
                }
            } else {
                false
            }
        } else {
            i.started.set(true);
            !isEmpty_1(i.stack.get().clone())
        }
    }
    pub fn choose<_a: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<_a>>>) -> _a {
        Set_::minElement(s)
    }
    pub fn copyToArray<_a: Clone + 'static>(
        s: Option<Lrc<Set_::SetTree_1<_a>>>,
        arr: Lrc<MutCell<Vec<_a>>>,
        i: i32,
    ) {
        let j: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
        Set_::iterate(
            Lrc::from({
                let arr = arr.clone();
                let j = j.clone();
                move |x: _a| {
                    arr.get_mut()[j.get() as usize] = x.clone();
                    j.set(j.get() + 1i32)
                }
            }),
            s,
        )
    }
    pub fn toArray<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> Lrc<MutCell<Vec<T>>> {
        let res: Lrc<MutCell<Vec<T>>> = arrayWithCapacity::<T>(Set_::count(s.clone()));
        Set_::iterate(
            Lrc::from({
                let res = res.clone();
                move |x: T| res.get_mut().push(x.clone())
            }),
            s.clone(),
        );
        res.clone()
    }
    pub fn toList<T: Clone + 'static>(s: Option<Lrc<Set_::SetTree_1<T>>>) -> List_1<T> {
        Set_::foldBack(
            Lrc::from(move |k: T, acc: List_1<T>| cons(k.clone(), acc.clone())),
            s,
            empty_1::<T>(),
        )
    }
    pub fn ofArray<_a: PartialOrd + Clone + 'static>(
        xs: Lrc<MutCell<Vec<_a>>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        fold_2(
            Lrc::from(move |acc: Option<Lrc<Set_::SetTree_1<_a>>>, k: _a| {
                Set_::add(k.clone(), acc.clone())
            }),
            Set_::empty(),
            xs,
        )
    }
    pub fn ofList<_a: PartialOrd + Clone + 'static>(
        xs: List_1<_a>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        fold_3(
            Lrc::from(move |acc: Option<Lrc<Set_::SetTree_1<_a>>>, k: _a| {
                Set_::add(k.clone(), acc.clone())
            }),
            Set_::empty(),
            xs,
        )
    }
    pub fn ofSeq<_a: PartialOrd + Clone + 'static>(
        xs: Lrc<dyn IEnumerable_1<_a>>,
    ) -> Option<Lrc<Set_::SetTree_1<_a>>> {
        fold_1(
            Lrc::from(move |acc: Option<Lrc<Set_::SetTree_1<_a>>>, k: _a| {
                Set_::add(k.clone(), acc.clone())
            }),
            Set_::empty(),
            xs,
        )
    }
    pub fn toSeq<T: PartialOrd + Clone + 'static>(
        s: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> Lrc<dyn IEnumerable_1<T>> {
        delay(Lrc::from({
            let s = s.clone();
            move || {
                unfold(
                    Lrc::from(move |i: Lrc<Set_::SetIterator_1<T>>| {
                        if Set_::moveNext(i.clone()) {
                            Some(Lrc::from((Set_::current(i.clone()), i.clone())))
                        } else {
                            None::<Lrc<(T, Lrc<Set_::SetIterator_1<T>>)>>
                        }
                    }),
                    Set_::mkIterator(s.clone()),
                )
            }
        }))
    }
    pub fn compareTo<T: PartialOrd + Clone + 'static>(
        s1: Option<Lrc<Set_::SetTree_1<T>>>,
        s2: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> i32 {
        compareWith(
            Lrc::from(move |e: T, e_1: T| compare(e.clone(), e_1.clone())),
            Set_::toSeq(s1),
            Set_::toSeq(s2),
        )
    }
    pub fn equals<T: PartialOrd + Clone + 'static>(
        s1: Option<Lrc<Set_::SetTree_1<T>>>,
        s2: Option<Lrc<Set_::SetTree_1<T>>>,
    ) -> bool {
        Set_::compareTo(s1, s2) == 0i32
    }
}
